; LC86104C/108C disassembler. (C) 1999-2000 John Maushammer.
;  Version 1.04                             john@maushammer.com
;  GNU public liscense - see www.gnu.org
;
;
; Source file=4WINS.VMS, 13568 (0x3500) bytes.
; Assembler output mode output enabled.
; Mapping memory...   reset/start entry point
; Mapping memory...   interrupt entry points
; Searching for text strings... (7 strings found)
; Done mapping memory.

fourwins:       MOV    #$a1,OCR          ;set 32 kHz clock speed (normal)
             MOV    #$09,MCR
             MOV    #$80,VCCR         ;turn on LCD
             CLR1   P3INT, 0          ;disable port 3 interrupts
             CLR1   P1, 7
             MOV    #$ff,P3           ;allow us to read buttons
             MOV    #$01,$01e
L1013:       XOR    ACC
             ST     $058
             ST     $059
             ST     $05a
             ST     $05b
             ST     $05c
             ST     $05d
             ST     $05e
             ST     $05f
             MOV    #<fourwins_24e7,TRL
             MOV    #>fourwins_24e7,TRH
             CALLF  L1DAD
L102E:       CALLF  L199E
             BP     ACC, 4, L102E
             BP     ACC, 5, L102E
             CALLF  L1D71
             CLR1   PSW, 1            ;access OS ram bank
             LD     $01c
             XOR    $01d
             SET1   PSW, 1            ;access game ram bank
             ST     $094
             MOV    #$03,$026
             MOV    #$00,$012
             MOV    #$64,$013
L104D:       MOV    #<fourwins_280e,TRL
             MOV    #>fourwins_280e,TRH
             CALLF  L1AC6
             BR     L1077

L1058:       XOR    ACC
             MOV    #$01,B
             MOV    #$04,C
             CALLF  L1853
             LD     $01a
             BNE    #$04,L106A
             JMP    L10DB

L106A:       BNE    #$01,L10BD
             INC    $026
             LD     $026
             BNE    #$06,L1077
             MOV    #$00,$026
L1077:       LD     $026
             BZ     L108A
             BE     #$01,L1092
             BE     #$02,L109A
             BE     #$03,L10A2
             BE     #$04,L10AA
             BE     #$05,L10B2
L108A:       MOV    #<fourwins_2834,TRL
             MOV    #>fourwins_2834,TRH
             BR     L10B8

L1092:       MOV    #<fourwins_2852,TRL
             MOV    #>fourwins_2852,TRH
             BR     L10B8

L109A:       MOV    #<fourwins_2871,TRL
             MOV    #>fourwins_2871,TRH
             BR     L10B8

L10A2:       MOV    #<fourwins_288f,TRL
             MOV    #>fourwins_288f,TRH
             BR     L10B8

L10AA:       MOV    #<fourwins_28ad,TRL
             MOV    #>fourwins_28ad,TRH
             BR     L10B8

L10B2:       MOV    #<fourwins_28cb,TRL
             MOV    #>fourwins_28cb,TRH
L10B8:       CALLF  L1AC6
             BR     L1058

L10BD:       BNE    #$02,L10CC
             LD     $026
             BZ     L1058
             BE     #$03,L1058
             CALLF  L189C
             BR     L104D

L10CC:       LD     $026
             BE     #$03,L10D3
             BNZ    L1129
L10D3:       XOR    ACC
             ST     $012
             ST     $013
             JMP    L1129

L10DB:       MOV    #$00,$019
             MOV    #$01,$01a
             PUSH   $019
             PUSH   $01a
L10E5:       MOV    #<fourwins_28e9,TRL
             MOV    #>fourwins_28e9,TRH
             CALLF  L1AC6
L10EE:       POP    $01a
             POP    $019
             XOR    ACC
             MOV    #$01,B
             MOV    #$04,C
             CALLF  L1853
             PUSH   $019
             PUSH   $01a
             LD     $01a
             BE     #$01,L1113
             BE     #$02,L111E
             BNE    #$04,L10EE
             POP    $01a
             POP    $019
             JMPF   L104D

L1113:       MOV    #<fourwins_2f3e,TRL
             MOV    #>fourwins_2f3e,TRH
             CALLF  L1AC6
             BR     L10E5

L111E:       MOV    #<fourwins_298b,TRL
             MOV    #>fourwins_298b,TRH
             CALLF  L1AC6
             BR     L10E5

L1129:       CALLF  L1349
             MOV    #$00,$055
             MOV    #$00,$054
             MOV    #$00,$057
             MOV    #$00,$056
             MOV    #$05,$01c
             CALLF  L1D71
L113E:       MOV    #$00,$025
             MOV    #$00,$052
             MOV    #$00,$053
             MOV    #$00,$01a
             CALLF  L1356
             BZ     L115B
             CALLF  L1349
             MOV    #<fourwins_2795,TRL
             MOV    #>fourwins_2795,TRH
             CALLF  L1AC6
L115B:       LD     $026
             SUB    #$03
             BP     PSW, 7, L117A      ;branch if carry set
             LD     $01e
             ST     $01b
             BNE    #$02,L117A
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             CALLF  L1F61
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             LD     $01e
             ST     $01b
             LD     $01c
             ST     $019
             JMPF    L11CB

L117A:       LD     $01e
             ST     $01b
             LD     $01c
             ST     $019
             CALLF  L136E
             MOV    #$03,ACC
             CALLF  L149A
L118B:       CALLF  L199E
             BN     ACC, 3, L11AF
             BN     ACC, 2, L119C
             BN     ACC, 4, L11CB
             BN     ACC, 5, L11C3
             BR     L118B

L119C:       LD     $01c
             BZ     L118B
             MOV    #$00,$01b
             CALLF  L136E
             XOR    ACC
             CALLF  L149A
             DEC    $01c
             BR     L117A

L11AF:       LD     $01c
             BE     #$0b,L118B
             MOV    #$00,$01b
             CALLF  L136E
             XOR    ACC
             CALLF  L149A
             INC    $01c
             BR     L117A

L11C3:       CALLF  L17D1
             CALLF  L144F
             JMPF    L113E

L11CB:       MOV    #$00,$01b
             CALLF  L136E
             XOR    ACC
             CALLF  L149A
             BZ     L117A
             SUB    #$01
             ST     $01d
             LD     $01e
             CALLF  L1414
             CALLF  L1677
             LD     $026
             BZ     L11F9
             BE     #$01,L122E
             BE     #$02,L126B
             BE     #$03,L11F9
             BE     #$04,L122E
             BE     #$05,L126B
             BR     L11F9

L11F9:       MOV    #$00,$025
             LD     $01e
             ST     $01b
             CALLF  L1DEE
             SUB    #$03
             BP     PSW, 7, L1226      ;branch if carry set
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             CALLF  L14CA
             CALLF  L1568
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             MOV    #$01,$052
             MOV    #$01,$053
             MOV    #$01,ACC
             CALLF  L16FE
             CALLF  L174D
             BZ     L1226
             BRF    L12B2

L1226:       LD     $01e
             XOR    #$03
             ST     $01e
             JMPF    L113E

L122E:       MOV    #$00,B
L1231:       MOV    #$00,$025
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             CALLF  L14CA
             CALLF  L1568
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             LD     $025
             BNZ    L124E
             LD     B
             BNZ    L1264
             LD     $01e
             XOR    #$03
             ST     $01e
             BR     L1264

L124E:       CALLF  L1643
             CALLF  L16EE
             CALLF  L16FE
             CALLF  L1697
             LD     $01e
             XOR    #$03
             ST     $01e
             INC    B
             BR     L1231

L1264:       CALLF  L174D
             BNZ    L12B2
             JMPF    L113E

L126B:       MOV    #$02,B
             MOV    #$02,C
L1271:       MOV    #$00,$025
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             CALLF  L14CA
             CALLF  L1568
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             DEC    B
             DEC    C
             LD     $025
             BZ     L1292
             MOV    #$02,C
             CALLF  L1643
             CALLF  L16EE
             CALLF  L16FE
L1292:       LD     B
             BNZ    L12A3
             LD     C
             BZ     L12AB
             MOV    #$02,C
             MOV    #$02,B
             CALLF  L1697
L12A3:       LD     $01e
             XOR    #$03
             ST     $01e
             BR     L1271

L12AB:       CALLF  L174D
             BNZ    L12B2
             JMPF   L113E

L12B2:       BNE    #$ff,L12BD
             MOV    #<fourwins_2756,TRL
             MOV    #>fourwins_2756,TRH
             BR     L12CE

L12BD:       BNE    #$01,L12C8
             MOV    #<fourwins_26d8,TRL
             MOV    #>fourwins_26d8,TRH
             BR     L12CE

L12C8:       MOV    #<fourwins_2717,TRL
             MOV    #>fourwins_2717,TRH
L12CE:       CALLF  L1AC6
             CALLF  L1799
             MOV    #$00,$019
             MOV    #$01,$01a
             PUSH   $019
             PUSH   $01a
L12DE:       MOV    #<fourwins_2918,TRL
             MOV    #>fourwins_2918,TRH
             CALLF  L1AC6
             POP    $01a
             POP    $019
             XOR    ACC
             MOV    #$01,B
             MOV    #$04,C
             CALLF  L1853
             PUSH   $019
             PUSH   $01a
             LD     $01a
             BNE    #$01,L1310
             CALLF  L1D71
             CALLF  L144F
L1305:       CALLF  L199E
             BN     ACC, 4, L12DE
             BN     ACC, 5, L12DE
             BR     L1305

L1310:       BNE    #$02,L131B
             CALLF  L17D1
             CALLF  L180D
             BR     L12DE

L131B:       BNE    #$03,L132A
             POP    $01a
             POP    $019
             LD     $01e
             XOR    #$03
             ST     $01e
             JMPf    L1129

L132A:       MOV    #<fourwins_294d,TRL
             MOV    #>fourwins_294d,TRH
             CALLF  L1AC6
             XOR    ACC
             MOV    #$03,B
             MOV    #$04,C
             CALLF  L1853
             LD     $01a
             BE     #$04,L12DE
             POP    $01a
             POP    $019
             JMPf    L1013

L1349:       MOV    #$27,$000
L134C:       MOV    #$00, @R0
             INC    $000
             LD     $000
             BNE    #$51,L134C
             RET    

L1356:       MOV    #$27,$000
L1359:       LD     @R0
             AND    #$f0
             BZ     L136D
             LD     @R0
             AND    #$0f
             BZ     L136D
             INC    $000
             LD     $000
             SUB    #$2d
             BNZ    L1359
             XOR    #$ff
L136D:       RET    

L136E:       PUSH   OCR
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             PUSH   ACC
             PUSH   B
             PUSH   C
             PUSH   XBNK
             PUSH   $002
             PUSH   TRL
             PUSH   TRH
             MOV    #<fourwins_25a7,TRL
             MOV    #>fourwins_25a7,TRH
             LD     $01b
             ROL    
             ROL    
             ST     C
             MOV    #$01,XBNK
             BP     $01a, 2, L1395
             MOV    #$00,XBNK
L1395:       LD     $01a
             CLR1   ACC, 2
             ROL    
             ROL    
             ROL    
             ROL    
             ROL    
             ST     $002
             LD     $019
             CLR1   PSW, 7             ;clear carry flag
             RORC   
             ADD    $002
             ADD    #$80
             ST     $002
L13AB:       LD     @R2
             BN     $019, 0, L13BA
             AND    #$f0
             ST     B
             LD     C
             LDC    
             AND    #$0f
             BR     L13C3

L13BA:       AND    #$0f
             ST     B
             LD     C
             LDC    
             AND    #$f0
L13C3:       OR     B
             ST     @R2
             INC    C
             LD     C
             AND    #$03
             BZ     L13DB
             LD     $002
             BP     C, 0, L13D5
             ADD    #$04
L13D5:       ADD    #$06
             ST     $002
             BR     L13AB

L13DB:       POP    TRH
             POP    TRL
             POP    $002
             POP    XBNK
             POP    C
             POP    B
             POP    ACC
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             POP    OCR
             RET    

L13EE:       PUSH   $000
             LD     $01d
             ROL    
             ST     $000
             ROL    
             ADD    $000
             ADD    #$27
             ST     $000
             LD     $01c
             RORC   
             ADD    $000
             ST     $000
             LD     @R0
             BP     $01c, 0, L140F
             AND    #$f0
             ROR    
             ROR    
             ROR    
             ROR    
             BR     L1411

L140F:       AND    #$0f
L1411:       POP    $000
             RET    

L1414:       PUSH   ACC
             PUSH   B
             PUSH   $000
             ST     B
             LD     $01d
             ROL    
             ST     $000
             ROL    
             ADD    $000
             ADD    #$27
             ST     $000
             LD     $01c
             RORC   
             ADD    $000
             ST     $000
             BP     $01c, 0, L1442
             LD     B
             ROL    
             ROL    
             ROL    
             ROL    
             ST     B
             LD     @R0
             AND    #$0f
             OR     B
             ST     @R0
             BR     L1448

L1442:       LD     @R0
             AND    #$f0
             OR     B
             ST     @R0
L1448:       POP    $000
             POP    B
             POP    ACC
             RET    

L144F:       PUSH   ACC
             PUSH   B
             PUSH   C
             PUSH   $01c
             PUSH   $01d
             PUSH   $019
             PUSH   $01a
             PUSH   $01b
             MOV    #$0c,B
L1462:       MOV    #$07,C
L1465:       LD     B
             DEC    ACC
             ST     $01c
             LD     C
             DEC    ACC
             ST     $01d
             CALLF  L13EE
             ST     $01b
             LD     $01c
             ST     $019
             LD     $01d
             INC    ACC
             ST     $01a
             CALLF  L136E
             DBNZ   C,L1465
             DBNZ   B,L1462
             POP    $01b
             POP    $01a
             POP    $019
             POP    $01d
             POP    $01c
             POP    C
             POP    B
             POP    ACC
             RET    

L149A:       PUSH   $01d
             PUSH   $01a
             PUSH   $019
             PUSH   $01b
             ST     $01b
             LD     $01c
             ST     $019
             MOV    #$00,$01d
L14AB:       CALLF  L13EE
             BNZ    L14BF
             LD     $01d
             INC    ACC
             ST     $01a
             CALLF  L136E
             INC    $01d
             SUB    #$07
             BNZ    L14AB
L14BF:       LD     $01d
             POP    $01b
             POP    $019
             POP    $01a
             POP    $01d
             RET    

L14CA:       PUSH   ACC
             PUSH   B
             PUSH   C
             PUSH   $01c
             PUSH   $01d
             PUSH   $000
             PUSH   $001
             MOV    #$00,C
             MOV    #$1c,$000
             MOV    #$1d,$001
             MOV    #$0c,$021
             MOV    #$07,$022
L14E7:       MOV    #$00, @R1
L14E9:       MOV    #$00,$020
             MOV    #$00, @R0
L14EE:       CALLF  L13EE
             BE     #$04,L14F7
             BNE    $01e,L14FB
L14F7:       INC    $020
             BR     L1508

L14FB:       LD     $020
             SUB    #$04
             BP     PSW, 7, L1505      ;branch if carry set
             CALLF  L1541
L1505:       MOV    #$00,$020
L1508:       INC    @R0
             LD     @R0
             SUB    $021
             BNZ    L14EE
             LD     $020
             SUB    #$04
             BP     PSW, 7, L1518      ;branch if carry set
             CALLF  L1541
L1518:       INC    @R1
             LD     @R1
             SUB    $022
             BNZ    L14E9
             LD     C
             BNZ    L1532
             INC    C
             LD     $000
             XCH    $001
             ST     $000
             LD     $021
             XCH    $022
             ST     $021
             BR     L14E7

L1532:       POP    $001
             POP    $000
             POP    $01d
             POP    $01c
             POP    C
             POP    B
             POP    ACC
             RET    

L1541:       PUSH   ACC
             LD     @R0
             PUSH   ACC
             DEC    @R0
L1547:       CALLF  L13EE
             BE     #$04,L155C
             BNE    $01e,L1562
             MOV    #$04,ACC
             CALLF  L1414
             CALLF  L1677
             MOV    #$01,$025
L155C:       LD     @R0
             BZ     L1562
             DEC    @R0
             BR     L1547

L1562:       POP    ACC
             ST     @R0
             POP    ACC
             RET    

L1568:       PUSH   ACC
             PUSH   B
             PUSH   $01c
             PUSH   $023
             PUSH   $01d
             PUSH   $024
             PUSH   $020
             MOV    #$00,B
L1579:       MOV    #$00,$023
             MOV    #$03,$024
L157F:       MOV    #$00,$020
             LD     $024
             ST     $01d
             LD     $023
             ST     $01c
L158A:       CALLF  L13EE
             BE     #$04,L1593
             BNE    $01e,L1597
L1593:       INC    $020
             BR     L15A4

L1597:       LD     $020
             SUB    #$04
             BP     PSW, 7, L15A1      ;branch if carry set
             CALLF  L1600
L15A1:       MOV    #$00,$020
L15A4:       INC    $01c
             LD     B
             BZ     L15B2
             LD     $01d
             DEC    $01d
             BZ     L15C0
             BR     L15BA

L15B2:       LD     $01d
             INC    $01d
             SUB    #$06
             BZ     L15C0
L15BA:       LD     $01c
             SUB    #$0c
             BNZ    L158A
L15C0:       LD     $020
             SUB    #$04
             BP     PSW, 7, L15CA      ;branch if carry set
             CALLF  L1600
L15CA:       LD     B
             BZ     L15D8
             LD     $024
             SUB    #$06
             BZ     L15E0
             INC    $024
             BR     L157F

L15D8:       LD     $024
             BZ     L15E0
             DEC    $024
             JMPf    L157F

L15E0:       INC    $023
             LD     $023
             BE     #$09,L15E9
             JMPf    L157F

L15E9:       LD     B
             BNZ    L15F1
             INC    B
             JMPf    L1579

L15F1:       POP    $020
             POP    $024
             POP    $01d
             POP    $023
             POP    $01c
             POP    B
             POP    ACC
             RET    

L1600:       PUSH   ACC
             PUSH   $01c
             PUSH   $01d
             MOV    #$01,$025
L1609:       LD     B
             BZ     L161C
             LD     $01c
             BZ     L163C
             LD     $01d
             BE     #$06,L163C
             DEC    $01c
             INC    $01d
             BR     L1628

L161C:       LD     $01c
             BZ     L163C
             LD     $01d
             BZ     L163C
             DEC    $01c
             DEC    $01d
L1628:       CALLF  L13EE
             BE     #$04,L1609
             BNE    $01e,L163C
             MOV    #$04,ACC
             CALLF  L1414
             CALLF  L1677
             BR     L1609

L163C:       POP    $01d
             POP    $01c
             POP    ACC
             RET    

L1643:       PUSH   B
             PUSH   $01c
             PUSH   $01d
             MOV    #$00,B
             MOV    #$0b,$01c
L164F:       MOV    #$06,$01d
L1652:       CALLF  L13EE
             BNE    #$04,L1662
             XOR    ACC
             CALLF  L1414
             CALLF  L1677
             INC    B
L1662:       LD     $01d
             DEC    $01d
             BNZ    L1652
             LD     $01c
             DEC    $01c
             BNZ    L164F
             POP    $01d
             POP    $01c
             LD     B
             POP    B
             RET    

L1677:       PUSH   ACC
             PUSH   $019
             PUSH   $01a
             PUSH   $01b
             ST     $01b
             LD     $01d
             ADD    #$01
             ST     $01a
             LD     $01c
             ST     $019
             CALLF  L136E
             POP    $01b
             POP    $01a
             POP    $019
             POP    ACC
             RET    

L1697:       PUSH   ACC
             PUSH   B
             PUSH   C
             PUSH   $01c
             PUSH   $01d
             MOV    #$0b,$01c
L16A4:       MOV    #$06,$01d
             MOV    #$00,B
L16AA:       CALLF  L13EE
             ST     C
             BNZ    L16BB
             LD     B
             BNZ    L16D7
             LD     $01d
             ST     B
             BR     L16D7

L16BB:       LD     B
             BZ     L16D7
             PUSH   $01d
             ST     $01d
             LD     C
             CALLF  L1414
             CALLF  L1677
             POP    $01d
             XOR    ACC
             CALLF  L1414
             CALLF  L1677
             DEC    B
L16D7:       LD     $01d
             DEC    $01d
             BNZ    L16AA
             LD     $01c
             DEC    $01c
             BNZ    L16A4
             POP    $01d
             POP    $01c
             POP    C
             POP    B
             POP    ACC
             RET    

L16EE:       PUSH   ACC
             LD     $01e
             BNE    #$01,L16F9
             INC    $052
             BR     L16FB

L16F9:       INC    $053
L16FB:       POP    ACC
             RET    

L16FE:       PUSH   ACC
             PUSH   B
             PUSH   C
             ST     C
             LD     $01e
             BNE    #$01,L172C
             LD     C
             MOV    #$00,ACC
             LD     $052
             ST     B
             MOV    #$00,ACC
             MUL                         ; B:ACC:C <- ACC:C * B
             CLR1   PSW, 7             ;clear carry flag
             PUSH   ACC
             LD     $055
             ADD    C
             ST     $055
             POP    C
             LD     $054
             ADDC   C
             ST     $054
             BR     L1746

L172C:       LD     $053
             ST     B
             MOV    #$00,ACC
             MUL                         ; B:ACC:C <- ACC:C * B
             PUSH   ACC
             LD     $057
             ADD    C
             ST     $057
             POP    C
             LD     $056
             ADDC   C
             ST     $056
             BR     L1746

L1746:       POP    C
             POP    B
             POP    ACC
             RET    

L174D:       PUSH   B
             LD     $013
             SUB    $055
             ST     B
             LD     $012
             SUBC   $054
             BP     PSW, 7, L1776      ;branch if carry set
             OR     B
             BZ     L1776
             LD     $013
             SUB    $057
             ST     B
             LD     $012
             SUBC   $056
             BP     PSW, 7, L1776      ;branch if carry set
             OR     B
             BZ     L1776
             XOR    ACC
             POP    B
             RET    

L1776:       LD     $055
             SUB    $057
             ST     B
             LD     $054
             SUBC   $056
             OR     B
             BP     PSW, 7, L178D      ;branch if carry set
             BZ     L1793
             MOV    #$01,ACC
             POP    B
             RET    

L178D:       MOV    #$02,ACC
             POP    B
             RET    

L1793:       MOV    #$ff,ACC
             POP    B
             RET    

L1799:       PUSH   ACC
             LD     $05b
             ADD    $055
             ST     $05b
             LD     $05a
             ADDC   $054
             ST     $05a
             LD     $059
             ADDC   #$00
             ST     $059
             LD     $058
             ADDC   #$00
             ST     $058
             LD     $05f
             ADD    $057
             ST     $05f
             LD     $05e
             ADDC   $056
             ST     $05e
             LD     $05d
             ADDC   #$00
             ST     $05d
             LD     $05c
             ADDC   #$00
             MOV    #$00,ACC
             ST     $05c
             POP    ACC
             RET    

L17D1:       PUSH   ACC
             MOV    #<fourwins_27d4,TRL
             MOV    #>fourwins_27d4,TRH
             CALLF  L1AC6
             MOV    #$0b,$019
             MOV    #$01,$01a
             XOR    ACC
             ST     $060
             ST     $061
             LD     $054
             ST     $062
             LD     $055
             ST     $063
             CALLF  L1D25
             MOV    #$0b,$019
             MOV    #$04,$01a
             LD     $056
             ST     $062
             LD     $057
             ST     $063
             CALLF  L1D25
             CALLF  L1C42
             CALLF  L1D71
             POP    ACC
             RET    

L180D:       PUSH   ACC
             MOV    #<fourwins_27eb,TRL
             MOV    #>fourwins_27eb,TRH
             CALLF  L1AC6
             MOV    #$0b,$019
             MOV    #$02,$01a
             LD     $058
             ST     $060
             LD     $059
             ST     $061
             LD     $05a
             ST     $062
             LD     $05b
             ST     $063
             CALLF  L1D25
             MOV    #$0b,$019
             MOV    #$04,$01a
             LD     $05c
             ST     $060
             LD     $05d
             ST     $061
             LD     $05e
             ST     $062
             LD     $05f
             ST     $063
             CALLF  L1D25
             CALLF  L1C42
             CALLF  L1D71
             POP    ACC
             RET    

L1853:       PUSH   ACC
             PUSH   B
             PUSH   C
L1859:       MOV    #$04,ACC
             CALLF  L1A10
L185F:       CALLF  L199E
             BN     ACC, 4, L1895
             BN     ACC, 1, L1880
             BP     ACC, 0, L185F
             XOR    ACC
             CALLF  L1A10
             LD     $01a
             XOR    B
             BNZ    L187C
             LD     C
             ST     $01a
             BR     L1859

L187C:       DEC    $01a
             BR     L1859

L1880:       XOR    ACC
             CALLF  L1A10
             LD     $01a
             XOR    C
             BNZ    L1891
             LD     B
             ST     $01a
             BR     L1859

L1891:       INC    $01a
             BR     L1859

L1895:       POP    C
             POP    B
             POP    ACC
             RET    

L189C:       MOV    #<fourwins_2975,TRL
             MOV    #>fourwins_2975,TRH
             CALLF  L1AC6
             LD     $013
             ST     C
             LD     $012
             MOV    #$0a,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             XCH    B
             ST     $018
             LD     B
             MOV    #$0a,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             XCH    B
             ST     $017
             LD     B
             MOV    #$0a,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             XCH    B
             ST     $016
             LD     B
             MOV    #$0a,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             XCH    B
             ST     $015
             MOV    #$03,$014
L18D4:       MOV    #$01,$019
             MOV    #$03,$01a
             MOV    #$15,$000
L18DD:       LD     @R0
             ADD    #$10
             CALLF  L1A10
             INC    $000
             INC    $019
             LD     $000
             XOR    #$19
             BNZ    L18DD
L18ED:       MOV    #$5b,C
             CALLF  L1983
L18F3:       CALLF  L199E
             ST     B
             XOR    #$ff
             AND    #$0c
             BZ     L1904
             MOV    #$00,C
             CALLF  L1983
L1904:       LD     B
             BN     ACC, 3, L1925
             BN     ACC, 0, L1933
             BN     ACC, 1, L1945
             BN     ACC, 4, L195A
             BN     ACC, 5, L1982
             BP     ACC, 2, L18F3
             LD     $014
             BNZ    L1921
             MOV    #$03,$014
             BR     L18ED

L1921:       DEC    $014
             BR     L18ED

L1925:       LD     $014
             XOR    #$03
             BNZ    L192F
             ST     $014
             BR     L18ED

L192F:       INC    $014
             BR     L18ED

L1933:       MOV    #$15,ACC
             ADD    $014
             ST     $000
             LD     @R0
             XOR    #$09
             BNZ    L1942
             ST     @R0
             BR     L18D4

L1942:       INC    @R0
             BR     L18D4

L1945:       MOV    #$15,ACC
             ADD    $014
             ST     $000
             LD     @R0
             BNZ    L1956
             MOV    #$09,ACC
             ST     @R0
             BRF    L18D4

L1956:       DEC    @R0
             BRF    L18D4

L195A:       MOV    #$00,$012
             MOV    #$00,$013
             MOV    #$15,$000
L1963:       LD     $013
             ST     C
             LD     $012
             MOV    #$0a,B
             MUL                         ; B:ACC:C <- ACC:C * B
             ST     $012
             LD     C
             ADD    @R0
             ST     $013
             LD     $012
             ADDC   #$00
             ST     $012
             INC    $000
             LD     $000
             XOR    #$19
             BNZ    L1963
L1982:       RET    

L1983:       LD     $014
             ADD    #$01
             ST     $019
             MOV    #$02,$01a
             LD     C
             CALLF  L1A10
             MOV    #$04,$01a
             LD     C
             BZ     L199A
             ADD    #$02
L199A:       CALLF  L1A10
             RET    

L199E:       SET1   P3INT, 0          ;enable port 3 interrupts
             SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             BP     P7, 0, L19BE      ;branch if Dreamcast connected
             LD     P3                ;read buttons
             BN     ACC, 6, L19BE
             BN     ACC, 7, L19C1
             XOR    $01f
             BNZ    L19B7
             MOV    #$ff,ACC
             CLR1   P3INT, 0          ;disable port 3 interrupts
             RET    

L19B7:       XOR    $01f
             ST     $01f
             CLR1   P3INT, 0          ;disable port 3 interrupts
             RET    

L19BE:       JMPF   quit

L19C1:       SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             BN     P3, 7, L19C1      ;branch if Sleep button pressed
             MOV    #$00,VCCR         ;turn off LCD
L19C9:       SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             BP     P7, 0, L19BE      ;branch if Dreamcast connected
             BP     P3, 7, L19C9      ;branch if Sleep button isn't pressed
             MOV    #$80,VCCR         ;turn on LCD
L19D4:       SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             BN     P3, 7, L19D4      ;branch if Sleep button pressed
             BR     L199E

L19DB:       BP     P7, 0, L19BE      ;branch if Dreamcast connected
             LD     P3                ;read buttons
             BN     ACC, 6, L19F3
             BN     ACC, 7, L19F6
             XOR    $01f
             BNZ    L19B7
             MOV    #$ff,ACC
             RET    

             BYTE   $f2,$1f                          ;ascii "r."
             BYTE   $12,$1f,$a0                      ;ascii ".. "
L19F3:       JMPF   quit

L19F6:       SET1   PCON, 1           ;halt- CPU sleeps until interrupt
             BN     P3, 7, L19F6      ;branch if Sleep button pressed
             MOV    #$00,VCCR         ;turn off LCD
L19FE:       SET1   PCON, 1           ;halt- CPU sleeps until interrupt
             BP     P7, 0, L19BE      ;branch if Dreamcast connected
             BP     P3, 7, L19FE      ;branch if Sleep button isn't pressed
             MOV    #$80,VCCR         ;turn on LCD
L1A09:       SET1   PCON, 1           ;halt- CPU sleeps until interrupt
             BN     P3, 7, L1A09      ;branch if Sleep button pressed
             BR     L199E

L1A10:       PUSH   OCR
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             PUSH   ACC
             PUSH   B
             PUSH   C
             PUSH   XBNK
             PUSH   $002
             PUSH   TRL
             PUSH   TRH
             ST     $01b
             LD     $01a
             ROL    
             ROL    
             ROL    
             ROL    
             ST     B
             ROL    
             ADD    B
             ST     $002
             MOV    #<fourwins_25bb,TRL
             MOV    #>fourwins_25bb,TRH
             MOV    #$00,C
             LD     $01b
             ROL    
             ADD    $01b
             BN     PSW, 7, L1A44      ;branch if carry clear
             INC    TRH
L1A44:       ST     B
             LD     TRL
             ADD    B
             ST     TRL
             BN     PSW, 7, L1A51      ;branch if carry clear
             INC    TRH
L1A51:       LD     $019
             CLR1   PSW, 7             ;clear carry flag
             RORC   
             ADD    $002
             ADD    #$80
             ST     $002
L1A5C:       BP     ACC, 7, L1A69
             ADD    #$80
             ST     $002
             LD     XBNK
             XOR    #$01
             ST     XBNK
L1A69:       LD     @R2
             BP     $019, 0, L1A82
             AND    #$0f
             ST     B
             LD     C
             CLR1   PSW, 7             ;clear carry flag
             RORC   
             LDC    
             BN     C, 0, L1A7E
             ROL    
             ROL    
             ROL    
             ROL    
L1A7E:       AND    #$f0
             BR     L1A95

L1A82:       AND    #$f0
             ST     B
             LD     C
             CLR1   PSW, 7             ;clear carry flag
             RORC   
             LDC    
             BP     C, 0, L1A93
             ROR    
             ROR    
             ROR    
             ROR    
L1A93:       AND    #$0f
L1A95:       OR     B
             ST     @R2
             INC    C
             LD     C
             SUB    #$06
             BZ     L1AB3
             LD     $002
             AND    #$0f
             SUB    #$06
             LD     $002
             BP     PSW, 7, L1AAD      ;branch if carry set
             ADD    #$04
L1AAD:       ADD    #$06
             ST     $002
             BR     L1A5C

L1AB3:       POP    TRH
             POP    TRL
             POP    $002
             POP    XBNK
             POP    C
             POP    B
             POP    ACC
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             POP    OCR
             RET    

L1AC6:       PUSH   ACC
             PUSH   B
             PUSH   TRL
             PUSH   TRH
             MOV    #$01,$051
L1AD1:       BN     $051, 1, L1B05
             CALLF  L19DB
             XOR    #$ff
             AND    #$20
             BZ     L1B05
L1ADD:       XOR    ACC
             LDC    
             ST     B
L1AE2:       INC    TRL
             LD     TRL
             BNZ    L1AEA
             INC    TRH
L1AEA:       LD     B
             XOR    #$0e
             BNZ    L1AF5
             MOV    #$20,B
             BR     L1AE2

L1AF5:       LD     B
             BNZ    L1AFC
             JMPF   L1BF9

L1AFC:       XOR    #$04
             BNZ    L1ADD
             CLR1   $051, 1
             CALLF  L1D71
L1B05:       XOR    ACC
             LDC    
             BNZ    L1B0D
             JMPF   L1BF9

L1B0D:       ST     B
             INC    TRL
             LD     TRL
             BNZ    L1B17
             INC    TRH
L1B17:       LD     B
             SUB    #$20
             BN     PSW, 7, L1B9D      ;branch if carry clear
             LD     B
             BNE    #$0a,L1B2F
             MOV    #$00,$019
             INC    $01a
             CALLF  L1C02
             BZ     L1AD1
             JMP    L1ADD

L1B2F:       BNE    #$0b,L1B3D
             CALLF  L1C42
             BN     $051, 1, L1AD1
             BN     ACC, 5, L1ADD
             BR     L1AD1

L1B3D:       BNE    #$0c,L1B4B
             CALLF  L1D71
             XOR    ACC
             ST     $019
             ST     $01a
             BR     L1AD1

L1B4B:       BNE    #$0e,L1B51
             JMPF   L1BDB

L1B51:       BNE    #$01,L1B58
             SET1   $051, 0
             JMP    L1AD1

L1B58:       BNE    #$02,L1B5F
             CLR1   $051, 0
             JMP    L1AD1

L1B5F:       BNE    #$03,L1B66
             SET1   $051, 1
             JMP    L1AD1

L1B66:       BNE    #$04,L1B6D
             CLR1   $051, 1
             JMP    L1AD1

L1B6D:       BNE    #$05,L1B81
             MOV    #$06,ACC
L1B73:       CALLF  L1C6E
             DBNZ   ACC,L1B73
             MOV    #$00,$019
             MOV    #$04,$01a
             JMP    L1AD1

L1B81:       BNE    #$06,L1B88
             SET1   $051, 2
             JMP    L1AD1

L1B88:       BNE    #$07,L1B8F
             CLR1   $051, 2
             JMP    L1AD1

L1B8F:       BNE    #$08,L1B96
             SET1   $051, 3
             JMP    L1AD1

L1B96:       BNE    #$09,L1B9D
             CLR1   $051, 3
             JMP    L1AD1

L1B9D:       CALLF  L1C02
             BZ     L1BA4
             JMP    L1ADD

L1BA4:       LD     B
             AND    #$7f
             SUB    #$20
             BN     $051, 0, L1BAF
             BZ     L1BD6
L1BAF:       CALLF  L1A10
             BN     $051, 3, L1BD6
             PUSH   B
             MOV    #$19,B
L1BBA:       LD     $01f
             OR     #$10
             ST     $01f
             CALLF  L19DB
             BN     ACC, 4, L1BD4
             BN     $051, 1, L1BD1
             BP     ACC, 5, L1BD1
             POP    B
             JMPF   L1ADD

L1BD1:       DBNZ   B,L1BBA
L1BD4:       POP    B
L1BD6:       INC    $019
             JMPF   L1AD1

L1BDB:       XOR    ACC
             LDC    
             ST     B
             AND    #$0f
             ST     $01a
             LD     B
             AND    #$f0
             ROR    
             ROR    
             ROR    
             ROR    
             ST     $019
             INC    TRL
             LD     TRL
             BNZ    L1BF6
             INC    TRH
L1BF6:       JMPF   L1AD1

L1BF9:       POP    TRH
             POP    TRL
             POP    B
             POP    ACC
             RET    

L1C02:       LD     $019
             SUB    #$0c
             BP     PSW, 7, L1C0E      ;branch if carry set
             MOV    #$00,$019
             INC    $01a
L1C0E:       LD     $01a
             SUB    #$05
             BP     PSW, 7, L1C3F      ;branch if carry set
             BN     $051, 2, L1C29
             MOV    #$06,ACC
L1C1B:       CALLF  L1C6E
             DBNZ   ACC,L1C1B
             MOV    #$00,$019
             MOV    #$04,$01a
             BR     L1C3F

L1C29:       CALLF  L1C42
             BN     $051, 1, L1C36
             BP     ACC, 5, L1C36
             MOV    #$01,ACC
             RET    

L1C36:       CALLF  L1D71
             XOR    ACC
             ST     $01a
             ST     $019
L1C3F:       XOR    ACC
             RET    

L1C42:       PUSH   $002
             PUSH   XBNK
             MOV    #$01,XBNK
             MOV    #$f5,$002
             MOV    #$3c, @R2
             MOV    #$fb,$002
             MOV    #$18, @R2
L1C53:       CALLF  L199E
             BN     ACC, 1, L1C5F
             BN     ACC, 5, L1C5F
             BP     ACC, 4, L1C53
L1C5F:       MOV    #$f5,$002
             MOV    #$00, @R2
             MOV    #$fb,$002
             MOV    #$00, @R2
             POP    XBNK
             POP    $002
             RET    

L1C6E:       PUSH   OCR
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             PUSH   ACC
             PUSH   B
             PUSH   C
             PUSH   $002
             PUSH   XBNK
             MOV    #$06,B
L1C7F:       LD     B
             ROL    
             AND    #$01
             ST     XBNK
             LD     B
             OR     #$80
             ST     $002
             LD     @R2
             ST     C
             LD     B
             AND    #$0f
             SUB    #$06
             LD     B
             BN     PSW, 7, L1C9C      ;branch if carry clear
             SUB    #$04
L1C9C:       SUB    #$06
             PUSH   ACC
             ROL    
             AND    #$01
             ST     XBNK
             POP    ACC
             OR     #$80
             ST     $002
             LD     C
             ST     @R2
             LD     B
             AND    #$0f
             SUB    #$0b
             BP     PSW, 7, L1CBD      ;branch if carry set
             LD     B
             ADD    #$04
             ST     B
L1CBD:       INC    B
             LD     B
             BNZ    L1C7F
             MOV    #$f6,$002
             MOV    #$01,XBNK
L1CC9:       XOR    ACC
             ST     @R2
             INC    $002
             LD     $002
             BNE    #$fc,L1CC9
             POP    XBNK
             POP    $002
             POP    C
             POP    B
             POP    ACC
             POP    OCR
             RET    

             BYTE   $61,$00,$61,$02,$61,$03,$13,$02  ;ascii "a.a.a..."
             BYTE   $e1,$f0,$c0,$c0,$c0,$c0,$13,$03  ;ascii "ap@@@@.."
             BYTE   $a1,$0a,$7f,$01,$06,$03,$03,$81  ;ascii "!......."
             BYTE   $07,$13,$03,$03,$03,$81,$10,$20  ;ascii "....... "
             BYTE   $1a,$10,$62,$19,$03,$02,$e1,$0f  ;ascii "..b...a."
             BYTE   $13,$03,$a1,$0a,$7f,$01,$06,$03  ;ascii "..!....."
             BYTE   $03,$81,$07,$13,$03,$03,$03,$81
             BYTE   $10,$20,$1a,$10,$62,$19,$71,$03  ;ascii ". ..b.q."
             BYTE   $71,$02,$71,$00,$a0              ;ascii "q.q. "
L1D25:       PUSH   ACC
             PUSH   B
             PUSH   C
L1D2B:       LD     $061
             ST     C
             LD     $060
             MOV    #$0a,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             ST     $060
             LD     C
             ST     $061
             LD     $062
             ST     C
             LD     B
             MOV    #$0a,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             LD     C
             ST     $062
             LD     $063
             ST     C
             LD     B
             MOV    #$0a,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             LD     C
             ST     $063
             LD     B
             ADD    #$10
             CALLF  L1A10
             DEC    $019
             LD     $060
             OR     $061
             OR     $062
             OR     $063
             BNZ    L1D2B
             POP    C
             POP    B
             POP    ACC
             RET    

L1D71:       PUSH   OCR
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             PUSH   ACC
             PUSH   XBNK
             PUSH   $002
             PUSH   C
             MOV    #$00,XBNK
L1D80:       MOV    #$80,$002
L1D83:       MOV    #$00, @R2
             INC    $002
             LD     $002
             AND    #$0f
             BNE    #$0c,L1D94
             LD     $002
             ADD    #$04
             ST     $002
L1D94:       LD     $002
             BNZ    L1D83
             BP     XBNK, 0, L1DA0
             MOV    #$01,XBNK
             BR     L1D80

L1DA0:       POP    C
             POP    $002
             POP    XBNK
             POP    ACC
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             POP    OCR
             RET    

L1DAD:       PUSH   OCR
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             PUSH   ACC
             PUSH   XBNK
             PUSH   C
             PUSH   $002
             MOV    #$80,$002
             XOR    ACC
             ST     XBNK
             ST     C
L1DC2:       LDC    
             ST     @R2
             INC    $002
             LD     $002
             AND    #$0f
             BNE    #$0c,L1DDA
             LD     $002
             ADD    #$04
             ST     $002
             BNZ    L1DDA
             INC    XBNK
             MOV    #$80,$002
L1DDA:       INC    C
             LD     C
             BNE    #$c0,L1DC2
             POP    $002
             POP    C
             POP    XBNK
             POP    ACC
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             POP    OCR
             RET    

L1DEE:       PUSH   B
             PUSH   C
             PUSH   $01c
             PUSH   $01d
             PUSH   $01b
             LD     $01c
             ST     $010
             LD     $01d
             ST     $011
             MOV    #$00,B
             MOV    #$01,C
L1E06:       LD     $010
             SUB    C
             ST     $01c
             BP     PSW, 7, L1E1D      ;branch if carry set
             CALLF  L13EE
             XOR    $01b
             BNZ    L1E1D
             INC    C
             LD     C
             BNE    #$04,L1E06
L1E1D:       LD     C
             SUB    #$01
             ST     B
             MOV    #$01,C
L1E26:       LD     $010
             ADD    C
             ST     $01c
             SUB    #$0c
             BN     PSW, 7, L1E3F      ;branch if carry clear
             CALLF  L13EE
             XOR    $01b
             BNZ    L1E3F
             INC    C
             LD     C
             BNE    #$04,L1E26
L1E3F:       LD     B
             ADD    C
             SUB    #$01
             ST     B
             PUSH   B
             MOV    #$01,C
L1E4C:       LD     $010
             SUB    C
             ST     $01c
             BP     PSW, 7, L1E6C      ;branch if carry set
             LD     $011
             SUB    C
             ST     $01d
             BP     PSW, 7, L1E6C      ;branch if carry set
             CALLF  L13EE
             XOR    $01b
             BNZ    L1E6C
             INC    C
             LD     C
             BNE    #$04,L1E4C
L1E6C:       DEC    C
             LD     C
             ST     B
             MOV    #$01,C
L1E75:       LD     $010
             ADD    C
             ST     $01c
             SUB    #$0c
             BN     PSW, 7, L1E99      ;branch if carry clear
             LD     $011
             ADD    C
             ST     $01d
             SUB    #$07
             BN     PSW, 7, L1E99      ;branch if carry clear
             CALLF  L13EE
             XOR    $01b
             BNZ    L1E99
             INC    C
             LD     C
             BNE    #$04,L1E75
L1E99:       LD     B
             ADD    C
             SUB    #$01
             ST     B
             POP    ACC
             ST     C
             SUB    B
             BP     PSW, 7, L1EAE      ;branch if carry set
             LD     C
             ST     B
L1EAE:       PUSH   B
             MOV    #$01,C
L1EB3:       LD     $010
             SUB    C
             ST     $01c
             BP     PSW, 7, L1ED5      ;branch if carry set
             LD     $011
             ADD    C
             ST     $01d
             SUB    #$07
             BN     PSW, 7, L1ED5      ;branch if carry clear
             CALLF  L13EE
             XOR    $01b
             BNZ    L1ED5
             INC    C
             LD     C
             BNE    #$04,L1EB3
L1ED5:       DEC    C
             LD     C
             ST     B
             MOV    #$01,C
L1EDE:       LD     $010
             ADD    C
             ST     $01c
             SUB    #$0c
             BN     PSW, 7, L1F00      ;branch if carry clear
             LD     $011
             SUB    C
             ST     $01d
             BP     PSW, 7, L1F00      ;branch if carry set
             CALLF  L13EE
             XOR    $01b
             BNZ    L1F00
             INC    C
             LD     C
             BNE    #$04,L1EDE
L1F00:       LD     B
             ADD    C
             SUB    #$01
             ST     B
             POP    ACC
             ST     C
             SUB    B
             BP     PSW, 7, L1F15      ;branch if carry set
             LD     C
             ST     B
L1F15:       PUSH   B
             LD     $010
             ST     $01c
             MOV    #$01,C
L1F1E:       LD     $011
             ADD    C
             ST     $01d
             SUB    #$07
             BN     PSW, 7, L1F37      ;branch if carry clear
             CALLF  L13EE
             XOR    $01b
             BNZ    L1F37
             INC    C
             LD     C
             BNE    #$04,L1F1E
L1F37:       LD     C
             SUB    #$01
             ST     B
             POP    ACC
             ST     C
             SUB    B
             BP     PSW, 7, L1F4A      ;branch if carry set
             LD     C
             ST     B
L1F4A:       LD     B
             SUB    #$03
             BP     PSW, 7, L1F54      ;branch if carry set
             MOV    #$03,B
L1F54:       LD     B
             POP    $01b
             POP    $01d
             POP    $01c
             POP    C
             POP    B
             RET    

L1F61:       MOV    #$7c,$000
             CALLF  L2095
             MOV    #$64,$000
             MOV    #$7c,$001
             CALLF  L20C3
             LD     $01e
             XOR    #$03
             ST     $01b
             MOV    #$70,$000
             CALLF  L20C3
             MOV    #$64,$000
             MOV    #$70,$001
             MOV    #$88,B
             CALLF  L213C
             MOV    #$88,$000
             MOV    #$7c,$001
             CALLF  L218F
             MOV    #$88,$000
             CALLF  L2059
             LD     B
             BNE    #$fe,L1F9F
             JMPF   L2038

L1F9F:       MOV    #$00,B
L1FA2:       MOV    #$88,ACC
             ADD    B
             ST     $000
             LD     @R0
             BE     #$fe,L1FCD
             BZ     L1FCD
             LD     B
             ST     $01c
             MOV    #$7c,ACC
             ADD    $01c
             ST     $000
             LD     @R0
             ST     $01d
             CALLF  L2231
             BZ     L1FCD
             MOV    #$88,ACC
             ADD    $01c
             ST     $000
             LD     @R0
             ADD    #$0d
             ST     @R0
L1FCD:       INC    B
             LD     B
             BNE    #$0c,L1FA2
L1FD4:       MOV    #$88,$000
             CALLF  L2059
             LD     B
             BE     #$fe,L2038
             LD     B
             BE     #$01,L2038
             LD     C
             BE     #$01,L1FEC
             CALLF  L21B4
L1FEC:       LD     $01e
             XOR    #$03
             ST     $01b
             MOV    #$7c,ACC
             ADD    $01c
             ST     $000
             LD     @R0
             ST     $01d
             LD     $01d
             BNZ    L2004
             XOR    ACC
             BR     L201C

L2004:       DEC    $01d
             CALLF  L2319
             INC    $01d
             SUB    #$09
             BN     PSW, 7, L202B      ;branch if carry clear
             DEC    $01d
             CALLF  L2359
             INC    $01d
             SUB    #$09
             BN     PSW, 7, L202B      ;branch if carry clear
L201C:       CALLF  L211E
             SUB    #$03
             BN     PSW, 7, L202B      ;branch if carry clear
             CALLF  L20F0
             BNZ    L202B
             BR     L2038

L202B:       MOV    #$88,ACC
             ADD    $01c
             ST     $001
             MOV    #$01, @R1
             BR     L1FD4

             BYTE   $71,$00                          ;ascii "q."
L2038:       RET    

L2039:       PUSH   B
             PUSH   C
             LD     $094
             ST     B
             MOV    #$4e,ACC
             MOV    #$6d,C
             MUL                         ; B:ACC:C <- ACC:C * B
             ST     B
             LD     C
             ADD    #$39
             ST     $094
             LD     B
             ADDC   #$30
             POP    C
             POP    B
             RET    

L2059:       PUSH   ACC
             PUSH   $000
             PUSH   $001
             MOV    #$7c,$001
             MOV    #$00,$01c
             MOV    #$ff,B
L2068:       LD     @R1
             BP     ACC, 7, L2085
             LD     B
             BE     #$ff,L2077
             SUB    @R0
             BZ     L2083
             BN     PSW, 7, L2085      ;branch if carry clear
L2077:       LD     @R0
             ST     B
             LD     $001
             SUB    #$7c
             ST     $01c
             MOV    #$00,C
L2083:       INC    C
L2085:       INC    $000
             INC    $001
             LD     $001
             BNE    #$88,L2068
             POP    $001
             POP    $000
             POP    ACC
             RET    

L2095:       PUSH   ACC
             PUSH   $000
             PUSH   $01c
             PUSH   $01d
             MOV    #$00,$01c
L20A0:       MOV    #$06,$01d
L20A3:       CALLF  L13EE
             BZ     L20AE
             LD     $01d
             DEC    $01d
             BNZ    L20A3
L20AE:       LD     $01d
             ST     @R0
             INC    $000
             INC    $01c
             LD     $01c
             BNE    #$0c,L20A0
             POP    $01d
             POP    $01c
             POP    $000
             POP    ACC
             RET    

L20C3:       PUSH   ACC
             PUSH   $000
             PUSH   $001
             PUSH   $01c
             PUSH   $01d
             MOV    #$00,$01c
L20D0:       LD     @R1
             BP     ACC, 7, L20DA
             ST     $01d
             CALLF  L1DEE
             ST     @R0
L20DA:       INC    $000
             INC    $001
             INC    $01c
             LD     $01c
             BNE    #$0c,L20D0
             POP    $01d
             POP    $01c
             POP    $001
             POP    $000
             POP    ACC
             RET    

L20F0:       PUSH   $001
             PUSH   $01d
             MOV    #$7c,ACC
             ADD    $01c
             ST     $001
             LD     @R1
             BZ     L211A
             SUB    #$01
             ST     $01d
             CALLF  L2319
             SUB    #$08
             BP     PSW, 7, L211A      ;branch if carry set
             CALLF  L2359
             SUB    #$08
             BP     PSW, 7, L211A      ;branch if carry set
             MOV    #$01,ACC
L2115:       POP    $01d
             POP    $001
             RET    

L211A:       XOR    ACC
             BR     L2115

L211E:       PUSH   $001
             PUSH   $01d
             MOV    #$7c,ACC
             ADD    $01c
             ST     $001
             LD     @R1
             BZ     L2138
             SUB    #$01
             ST     $01d
             CALLF  L1DEE
L2133:       POP    $01d
             POP    $001
             RET    

L2138:       XOR    ACC
             BR     L2133

L213C:       PUSH   ACC
             PUSH   B
             PUSH   $000
             PUSH   $001
             PUSH   $01c
             PUSH   TRL
             PUSH   TRH
             MOV    #$00,$01c
             MOV    #<fourwins_217f,TRL
             MOV    #>fourwins_217f,TRH
L2153:       LD     @R1
             ROL    
             ROL    
             ADD    @R0
             PUSH   $000
             XCH    B
             ST     $000
             XCH    B
             LDC    
             ST     @R0
             POP    $000
             INC    B
             INC    $000
             INC    $001
             INC    $01c
             LD     $01c
             BNE    #$0c,L2153
             POP    TRH
             POP    TRL
             POP    $01c
             POP    $001
             POP    $000
             POP    B
             POP    ACC
             RET    

fourwins_217f:
             BYTE   $03
             BYTE   $05,$07,$fe,$04,$06,$09,$fe,$08  ;ascii "..~...~."
             BYTE   $0a,$0b,$fe,$fe,$fe,$fe,$fe      ;ascii "..~~~~~"
L218F:       PUSH   ACC
             PUSH   $000
             PUSH   $001
             PUSH   $01c
             MOV    #$00,$01c
L219A:       LD     @R1
             BNE    #$ff,L21A0
             MOV    #$00, @R0
L21A0:       INC    $000
             INC    $001
             INC    $01c
             LD     $01c
             BNE    #$0c,L219A
             POP    $01c
             POP    $001
             POP    $000
             POP    ACC
             RET    

L21B4:       PUSH   ACC
             PUSH   B
             PUSH   C
             PUSH   $001
             CALLF  L2039
             ST     C
             AND    #$f0
             ROR    
             ROR    
             ROR    
             ROR    
             XOR    C
             AND    #$0f
             ST     C
L21CD:       LD     $000
             ADD    $01c
             ST     $001
             LD     @R1
             XOR    B
             BNZ    L21DE
             LD     C
             DEC    C
             BZ     L21EA
L21DE:       INC    $01c
             LD     $01c
             BNE    #$0c,L21CD
             MOV    #$00,$01c
             BR     L21CD

L21EA:       POP    $001
             POP    C
             POP    B
             POP    ACC
             RET    

L21F3:       LD     $01c
             BP     ACC, 7, L222A
             SUB    #$0c
             BN     PSW, 7, L222A      ;branch if carry clear
             LD     $01d
             BP     ACC, 7, L222A
             SUB    #$07
             BN     PSW, 7, L222A      ;branch if carry clear
             CALLF  L13EE
             BNZ    L2222
             LD     $01d
             BE     #$06,L221E
             ADD    #$01
             PUSH   $01d
             ST     $01d
             CALLF  L13EE
             POP    $01d
             BZ     L222E
L221E:       MOV    #$01,ACC
             RET    

L2222:       XOR    $01b
             BNZ    L222A
             MOV    #$04,ACC
             RET    

L222A:       MOV    #$ff,ACC
             RET    

L222E:       XOR    ACC
             RET    

L2231:       PUSH   B
             PUSH   C
             PUSH   $000
             PUSH   $001
             LD     $01c
             ST     B
             CALLF  L2319
             SUB    #$09
             BP     PSW, 7, L2247      ;branch if carry set
             JMPf    L2309

L2247:       LD     $01d
             BNZ    L224F
             XOR    ACC
             BR     L2256

L224F:       DEC    $01d
             CALLF  L2359
             INC    $01d
L2256:       SUB    #$0c
             BN     PSW, 7, L226F      ;branch if carry clear
             LD     $01d
             BNZ    L2261
             JMPf    L2305

L2261:       DEC    $01d
             CALLF  L2319
             INC    $01d
             SUB    #$0c
             BN     PSW, 7, L226F      ;branch if carry clear
             JMPf    L2305

L226F:       CALLF  L2319
             SUB    #$09
             BN     PSW, 7, L2281      ;branch if carry clear
             CALLF  L2359
             SUB    #$09
             BN     PSW, 7, L2281      ;branch if carry clear
             JMPf    L2305

L2281:       MOV    #$99,$000
             MOV    #$9f,$001
L2287:       LD     @R0
             ST     @R1
             INC    $000
             INC    $001
             LD     $000
             BNE    #$9f,L2287
             LD     $0a5
             ST     $0a6
             MOV    #$99,ACC
             ADD    $0a6
             MOV    #$00,C
             ST     $000
L22A0:       LD     @R0
             BE     #$01,L22AF
             INC    $000
             INC    C
             LD     C
             BNE    #$03,L22A0
             BR     L2305

L22AF:       MOV    #$00,B
             LD     $0a6
             ADD    C
             SUB    #$03
             BP     PSW, 7, L22BD      ;branch if carry set
             ADD    #$01
L22BD:       ST     B
             PUSH   $01c
             PUSH   $01d
             LD     $01c
             ADD    B
             ST     $01c
             MOV    #$7c,ACC
             ADD    $01c
             ST     $000
             LD     @R0
             ST     $01d
             LD     $01e
             XOR    #$03
             CALLF  L1414
             LD     $01c
             ST     B
             LD     $01d
             ST     C
             POP    $01d
             POP    $01c
             CALLF  L1DEE
             PUSH   ACC
             PUSH   $01c
             PUSH   $01d
             LD     B
             ST     $01c
             LD     C
             ST     $01d
             XOR    ACC
             CALLF  L1414
             POP    $01d
             POP    $01c
             POP    ACC
             BE     #$03,L2309
L2305:       XOR    ACC
             BR     L2310

L2309:       LD     B
             ST     $01c
             MOV    #$01,ACC
L2310:       POP    $001
             POP    $000
             POP    C
             POP    B
             RET    

L2319:       PUSH   B
             PUSH   $000
             PUSH   $01c
             PUSH   $01d
             LD     $01c
             ST     $096
             LD     $01d
             ST     $097
             MOV    #$99,$000
             LD     $097
             ST     $01d
             LD     $096
             SUB    #$03
             ST     $01c
             MOV    #$00,B
L2339:       CALLF  L21F3
             ST     @R0
L233D:       INC    $01c
             LD     $01c
             BE     $096,L233D
             INC    $000
             INC    B
             LD     B
             BNE    #$06,L2339
             CALLF  L2425
             POP    $01d
             POP    $01c
             POP    $000
             POP    B
             RET    

L2359:       PUSH   B
             PUSH   C
             PUSH   $000
             PUSH   $01c
             PUSH   $01d
             LD     $01c
             ST     $096
             LD     $01d
             ST     $097
             MOV    #$99,$000
             LD     $097
             SUB    #$03
             ST     $01d
             LD     $096
             SUB    #$03
             ST     $01c
             MOV    #$00,B
L237D:       CALLF  L21F3
             ST     @R0
L2381:       INC    $01d
             INC    $01c
             LD     $01c
             BE     $096,L2381
             INC    $000
             INC    B
             LD     B
             BNE    #$06,L237D
             CALLF  L2425
             ST     C
             MOV    #$99,$000
             LD     $097
             SUB    #$03
             ST     $01d
             LD     $096
             ADD    #$03
             ST     $01c
             MOV    #$00,B
L23AA:       CALLF  L21F3
             ST     @R0
L23AE:       INC    $01d
             DEC    $01c
             LD     $01c
             BE     $096,L23AE
             INC    $000
             INC    B
             LD     B
             BNE    #$06,L23AA
             CALLF  L2425
             ST     B
             SUB    C
             BP     PSW, 7, L23CE      ;branch if carry set
             LD     B
             ST     C
L23CE:       LD     C
             POP    $01d
             POP    $01c
             POP    $000
             POP    C
             POP    B
             RET    

             BYTE   $61,$02,$60,$00,$60              ;ascii "a.`.`"
             BYTE   $1c,$60,$1d,$02,$1c,$12,$96,$02  ;ascii ".`......"
             BYTE   $1d,$12,$97,$22,$00,$99,$02,$97  ;ascii "..."...."
             BYTE   $81,$03,$12,$1d,$02,$96,$12,$1c
             BYTE   $23,$02,$00,$20,$21,$f3,$14,$72  ;ascii "#.. !s.r"
             BYTE   $1d,$02,$1d,$32,$97,$f9,$62,$00  ;ascii "...2.yb."
             BYTE   $63,$02,$03,$02,$41,$03,$ec,$23  ;ascii "c...A.l#"
             BYTE   $00,$ff,$14,$62,$00,$14,$62,$00  ;ascii "...b..b."
             BYTE   $14,$20,$24,$25,$70,$1d,$70,$1c  ;ascii ". $%p.p."
             BYTE   $70,$00,$71,$02,$a0              ;ascii "p.q. "
L2425:       PUSH   B
             PUSH   C
             PUSH   $000
             MOV    #$00,B
             MOV    #$9b,$000
             LD     @R0
             BE     #$ff,L244B
             ST     B
             DEC    $000
             LD     @R0
             BE     #$ff,L244B
             ADD    B
             ST     B
             DEC    $000
             LD     @R0
             BE     #$ff,L244B
             ADD    B
             ST     B
L244B:       MOV    #$00,$0a5
             LD     B
             ST     C
             MOV    #$00,B
             MOV    #$9b,$000
             LD     @R0
             BE     #$ff,L2468
             ST     B
             DEC    $000
             LD     @R0
             BE     #$ff,L2468
             ADD    B
             ST     B
L2468:       MOV    #$9c,$000
             LD     @R0
             BE     #$ff,L2473
             ADD    B
             ST     B
L2473:       LD     B
             SUB    C
             BP     PSW, 7, L2481      ;branch if carry set
             MOV    #$01,$0a5
             LD     B
             ST     C
L2481:       MOV    #$00,B
             MOV    #$9b,$000
             LD     @R0
             BE     #$ff,L248D
             ST     B
L248D:       MOV    #$9c,$000
             LD     @R0
             BE     #$ff,L24A2
             ADD    B
             ST     B
             INC    $000
             LD     @R0
             BE     #$ff,L24A2
             ADD    B
             ST     B
L24A2:       LD     B
             SUB    C
             BP     PSW, 7, L24B0      ;branch if carry set
             MOV    #$02,$0a5
             LD     B
             ST     C
L24B0:       MOV    #$00,B
             MOV    #$9c,$000
             LD     @R0
             BE     #$ff,L24D0
             ST     B
             INC    $000
             LD     @R0
             BE     #$ff,L24D0
             ADD    B
             ST     B
             INC    $000
             LD     @R0
             BE     #$ff,L24D0
             ADD    B
             ST     B
L24D0:       LD     B
             SUB    C
             BP     PSW, 7, L24DE      ;branch if carry set
             MOV    #$03,$0a5
             LD     B
             ST     C
L24DE:       LD     C
             POP    $000
             POP    C
             POP    B
             RET    

