
*
* Special Function Register addresses
*

ACC	EQU	$100
PSW	EQU	$101
B	EQU	$102
C	EQU	$103
TRL	EQU	$104
TRH	EQU	$105
SP	EQU	$106
PCON	EQU	$107
IE	EQU	$108
IP	EQU	$109
EXT	EQU	$10D
OCR	EQU	$10E
T0CON	EQU	$110
T0PRR	EQU	$111
T0L	EQU	$112
T0LR	EQU	$113
T0H	EQU	$114
T0HR	EQU	$115
T1CNT	EQU	$118
T1LC	EQU	$11A
T1L	EQU	$11B
T1LR	EQU	$11B
T1HC	EQU	$11C
T1H	EQU	$11D
T1HR	EQU	$11D
MCR	EQU	$120
STAD	EQU	$122
CNR	EQU	$123
TDR	EQU	$124
XBNK	EQU	$125
VCCR	EQU	$127
SCON0	EQU	$130
SBUF0	EQU	$131
SBR	EQU	$132
SCON1	EQU	$134
SBUF1	EQU	$135
P1	EQU	$144
P1DDR	EQU	$145
P1FCR	EQU	$146
P3	EQU	$14C
P3DDR	EQU	$14D
P3INT	EQU	$14E
P7	EQU	$15C
I01CR	EQU	$15D
I23CR	EQU	$15E
ISL	EQU	$15F
VSEL	EQU	$163
VRMAD1	EQU	$164
VRMAD2	EQU	$165
VTRBF	EQU	$166
VLREG	EQU	$167
BTCR	EQU	$17F
XRAM	EQU	$180


*
* PSW bits
*
CY	EQU	7
AC	EQU	6
IRBK1	EQU	4
IRBK0	EQU	3
OV	EQU	2
RAMBK0  EQU     1
P       EQU     0

*
* PCON bits
*
HOLD	EQU	1
HALT	EQU	0

*
* IE bits (names guessed by sgust@ithh.infoserv.de)
*
MASTIE	EQU	7
INT1PRI	EQU	1
INT0PRI	EQU	0

*
* OCR bits (names guessed by sgust@ithh.infoserv.de)
*
HALFCLK	EQU	7
SUBCLK	EQU	5
MAINCLK	EQU	4
RCCTL	EQU	1
MAINCTL	EQU	0

*
* T0CON bits
*
T0HRUN	EQU	7
T0LRUN	EQU	6
T0LONG	EQU	5
ELDT0C	EQU	4
T0HOVF	EQU	3
T0HIE	EQU	2
T0LOVF	EQU	1
T0LIE	EQU	0

*
* T1CNT bits
*
T1HRUN	EQU	7
T1LRUN	EQU	6
T1LONG	EQU	5
ELDT1C	EQU	4
T1HOVF	EQU	3
T1HIE	EQU	2
T1LOVF	EQU	1
T1LIE	EQU	0

*
* P3INT bits (names guessed by sgust@ithh.infoserv.de)
*
P3HOLD	EQU	2
P3IFLAG	EQU	1
P3IE	EQU	0

*
* VSEL bit
INCE	EQU	4
*
