; LC86104C/108C disassembler. (C) 1999-2000 John Maushammer.
;  Version 1.04                             john@maushammer.com
;  GNU public liscense - see www.gnu.org
;
;
; Source file=PAPER.VMS, 9310 (0x245e) bytes.
; Mapping memory...   user-defined point $1115
; Mapping memory...   user-defined point $11f7
; Mapping memory...   user-defined point $1223
; Mapping memory...   user-defined point $1256
; Mapping memory...   user-defined point $12cd
; Mapping memory...   user-defined point $137c
; Mapping memory...   user-defined point $1432
; Mapping memory...   user-defined point $18b5
; Mapping memory...   reset/start entry point
; Mapping memory...   interrupt entry points
; Searching for text strings... (0 strings found)
; Done mapping memory.


paper:       CALLF   L1330
             CALLF   paper_L1341
             CALLF   L1464
paper_L1006:       MOV    #$00,$01e
             MOV    #$01,$01d
             MOV    #$03,$01f
             MOV    #$0f,$020
             MOV    #$3f,$021
             MOV    #$ff,$022
             MOV    #$0e,$024
             MOV    #$00,$023
             MOV    #$00,$02e
             MOV    #$04,$032
             CALLF   L15DD
             MOV    #$00,$010
             MOV    #$00,$015
             CLR1   $014, 0
             MOV    #$03,$01b
             MOV    #$00,$01c
             MOV    #$90,$04f
             MOV    #$18,$038
             MOV    #$40,$04d
             CALLF   L18A7
             CALLF   L11AA
             MOV    #<paper_1d6e,TRL
             MOV    #>paper_1d6e,TRH
             CALLF   paper_L11CA
             CALLF   L1441
             CALLF   L1D22
             CALLF   L11AA
L104F:       CALLF   L15E6
             CALLF   L13F1
             BP     $023, 0, paper_L10AA
             CALLF   L1A7F
             LD     $015
             BE     #$05,L10A8
             BN     PSW, 7, paper_L1092      ;branch if carry clear
             MOV    #$00,$025
             BP     P3, 0, L1074      ;branch if up button isn't pressed
             BN     P3, 1, L1082      ;branch if down button pressed
             LD     $024
             BE     #$06,L106E
L106E:       BP     PSW, 7, L1074      ;branch if carry set
             MOV    #$ff,$025
L1074:       BP     P3, 1, L1082      ;branch if down button isn't pressed
             LD     $024
             BE     #$17,paper_L107C
paper_L107C:       BN     PSW, 7, L1082      ;branch if carry clear
             MOV    #$01,$025
L1082:       BP     P3, 5, L108F      ;branch if B button isn't pressed
             BN     $01c, 0, paper_L1092
             MOV    #$00,$01c
             CALLF   L1A4C
             jmpf    paper_L1092

L108F:       MOV    #$01,$01c
paper_L1092:       BP     P3, 4, L10A8      ;branch if A button isn't pressed
             BP     $02e, 0, L10A8
             SET1   $02e, 0
             SET1   $02e, 1
             SET1   $02e, 2
             MOV    #$01,$02f
             MOV    #$03,ACC
             ADD    $024
             ST     $030
L10A8:       jmpf    L104F

paper_L10AA:       LD     $024
             BE     #$18,L10AF
L10AF:       BP     PSW, 7, L104F      ;branch if carry set
             jmpf    L10B7

paper_L10B4:       JMPF   quit

L10B7:       CALLF   L1420
             MOV    #<paper_1eee,TRL
             MOV    #>paper_1eee,TRH
             CALLF   paper_L11CA
             PUSH   P3INT
             MOV    #$05,P3INT
             SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             POP    P3INT
             CALLF   L18CD
             jmpf    paper_L1006

L10CE:       LD     B
             ST     $033
             LD     C
             ST     $034
             MOV    #$00,ACC
             LDC    
             ST     $035
             MOV    #$01,ACC
             LDC    
             ST     $036
             MOV    #$02,$037
             RET    

L10E6:       PUSH   OCR
             MOV    #$4d,OCR
             CALLF   L10CE
L10ED:       LD     $034
             CALLF   L118E
             LD     $002
             ADD    $033
             ST     $002
             LD     $035
             ST     B
L10FB:       LD     $037
             LDC    
             XOR    #$ff
             ST     C
             LD     @R2
             AND    C
             ST     @R2
             INC    $002
             INC    $037
             DBNZ   B,L10FB
             INC    $034
             DBNZ   $036,L10ED
             POP    OCR
             RET    

; fixed:
;             BYTE   $61,$0e,$23                      ;ascii "a.#"
;             BYTE   $0e,$4d,$08,$ce,$02,$34,$09,$8e  ;ascii ".M.N.4.."
;             BYTE   $02,$02,$82,$33,$12,$02,$02,$35  ;ascii "...3...5"
;             BYTE   $13,$02,$26,$00,$62,$02,$53,$02  ;ascii "..&.b.S."
;             BYTE   $f9,$62,$34,$52,$36,$e6,$71,$0e  ;ascii "yb4R6fq."
;             BYTE   $a0                              ;ascii " "

L1115:       PUSH   OCR
             MOV    #$4d,OCR
             callf   L10CE
L111C:       LD     $034
             CALLf   L118E
             LD     $002
             ADD    $033
             ST     $002
             LD     $035
             ST     B
paper_L112A:       MOV    #$00, @R2
             INC    $002
             DBNZ   B,paper_L112A
             INC    $034
             DBNZ   $036,L111C
             POP    OCR
             RET    

L1139:       PUSH   OCR
             MOV    #$4d,OCR
             CALLF   L10CE
L1140:       LD     $034
             CALLF   L118E
             LD     $002
             ADD    $033
             ST     $002
             LD     $035
             ST     B
L114E:       LD     $037
             LDC    
             ST     C
             LD     @R2
             OR     C
             ST     @R2
             INC    $002
             INC    $037
             DBNZ   B,L114E
             INC    $034
             DBNZ   $036,L1140
             POP    OCR
             RET    

L1166:       PUSH   OCR
             MOV    #$4d,OCR
             CALLF   L10CE
L116D:       LD     $034
             CALLF   L118E
             LD     $002
             ADD    $033
             ST     $002
             LD     $035
             ST     B
L117B:       LD     $037
             LDC    
             ST     @R2
             INC    $002
             INC    $037
             DBNZ   B,L117B
             INC    $034
             DBNZ   $036,L116D
             POP    OCR
             RET    

L118E:       ST     B
             BPC    ACC, 4, L1198
             MOV    #$00,XBNK
             jmpf    L119B

L1198:       MOV    #$01,XBNK
L119B:       ROL    
             ROL    
             ROL    
             AND    #$f0
             BN     B, 0, L11A5
             OR     #$06
L11A5:       OR     #$80
             ST     $002
             RET    

L11AA:       PUSH   OCR
             MOV    #$4d,OCR
             MOV    #$00,XBNK
             CALLF   L11BC
             MOV    #$01,XBNK
             CALLF   L11BC
             POP    OCR
             RET    

L11BC:       MOV    #$80,$002
             MOV    #$80,B
L11C2:       MOV    #$00, @R2
             INC    $002
             DBNZ   B,L11C2
             RET    

paper_L11CA:       PUSH   OCR
             MOV    #$4d,OCR
             MOV    #$00,C
             MOV    #$00,ACC
L11D5:       PUSH   ACC
             LD     C
             CALLF   L118E
             POP    ACC
             MOV    #$0c,B
L11E0:       PUSH   ACC
             LDC    
             ST     @R2
             INC    $002
             POP    ACC
             INC    ACC
             DBNZ   B,L11E0
             INC    C
             INC    C
             BN     C, 5, L11D5
             POP    OCR
             RET    

L11F7:       PUSH   OCR
             MOV    #$4d,OCR
             SET1   VSEL, 4
             MOV    #$00,VRMAD1
             MOV    #$00,VRMAD2
             MOV    #$20,C
             MOV    #$00,ACC
L120A:       PUSH   ACC
             callf   L118E
             MOV    #$06,B
L1211:       LD     @R2
             ST     VTRBF       ;write to work RAM
             INC    $002
             DBNZ   B,L1211
             POP    ACC
             INC    ACC
             DBNZ   C,L120A
             POP    OCR
             RET    

paper_L1223:       PUSH   OCR
             MOV    #$4d,OCR
             PUSH   B
             PUSH   C
             LD     C
             callf   L118E
             POP    C
             POP    B
             LD     $002
             ADD    B
             ST     $002
             PUSH   B
             LD     C
             MOV    #$00,ACC
             MOV    #$06,B
             MUL                         ; B:ACC:C <- ACC:C * B
             LD     C
             POP    B
             ADD    B
             ST     VRMAD1
             MOV    #$00,VRMAD2
             LD     VTRBF       ;read from work RAM
             ST     @R2
             POP    OCR
             RET    

L1256:       PUSH   OCR
             MOV    #$4d,OCR
             CLR1   VSEL, 4
             PUSH   ACC
             PUSH   B
             PUSH   C
             LD     C
             callf   L118E
             POP    C
             POP    B
             LD     $002
             ADD    B
             ST     $002
             PUSH   B
             PUSH   C
             LD     C
             MOV    #$00,ACC
             MOV    #$06,B
             MUL                         ; B:ACC:C <- ACC:C * B
             LD     C
             POP    C
             POP    B
             ADD    B
             ST     VRMAD1
             MOV    #$00,VRMAD2
             POP    ACC
L128D:       PUSH   ACC
             LD     VTRBF       ;read from work RAM
             ST     @R2
             LD     VRMAD1
             ADD    #$06
             ST     VRMAD1
             INC    C
             BP     C, 0, L12AF
             LD     C
             BE     #$10,L12BC
             LD     $002
             ADD    #$0a
             ST     $002
             POP    ACC
             DBNZ   ACC,L128D
             jmpf    L12CA

L12AF:       LD     $002
             ADD    #$06
             ST     $002
             POP    ACC
             DBNZ   ACC,L128D
             jmpf    L12CA

L12BC:       MOV    #$01,XBNK
             LD     $002
             SUB    #$76
             ST     $002
             POP    ACC
             DBNZ   ACC,L128D
L12CA:       POP    OCR
             RET    

L12CD:       PUSH   OCR
             MOV    #$4d,OCR
             PUSH   ACC
             PUSH   B
             PUSH   C
             LD     C
             callf   L118E
             POP    C
             POP    B
             LD     $002
             ADD    B
             ST     $002
             POP    ACC
L12E8:       PUSH   ACC
             MOV    #$00, @R2
             INC    C
             BP     C, 0, L1303
             LD     C
             BE     #$10,paper_L1310
             LD     $002
             ADD    #$0a
             ST     $002
             POP    ACC
             DBNZ   ACC,L12E8
             jmpf    L131E

L1303:       LD     $002
             ADD    #$06
             ST     $002
             POP    ACC
             DBNZ   ACC,L12E8
             jmpf    L131E

paper_L1310:       MOV    #$01,XBNK
             LD     $002
             SUB    #$76
             ST     $002
             POP    ACC
             DBNZ   ACC,L12E8
L131E:       POP    OCR
             RET    

; what is this stuff at
;	.org $1321
             BYTE   $01,$02,$04,$08,$10,$20,$40      ;ascii "..... @"
             BYTE   $80,$40,$20,$10,$08,$04,$02,$01  ;ascii ".@ ....."

L1330:       MOV    #$ef,OCR
             SET1   PSW, 1            ;access game ram bank
             SET1   IE, 7
             CLR1   P3INT, 0          ;disable port 3 interrupts
             CLR1   PSW, 3
             CLR1   PSW, 4
             MOV    #$09,MCR
             RET    

paper_L1341:       CLR1   PSW, 1            ;access OS ram bank
             LD     $01d
             SET1   PSW, 1            ;access game ram bank
             ST     $012
             XOR    #$ff
             ST     $013
             RET    

L134E:       MOV    #$08,B
             CALLF   L1355
             RET    

             BYTE   $a0                              ;ascii " "
L1355:       MOV    #$00,ACC
L1358:       PUSH   ACC
             LD     $013
             ROL    
             XOR    $013
             ROLC   
             ROLC   
             PUSH   PSW
             LD     $012
             ROLC   
             ST     $012
             LD     $013
             ROLC   
             ST     $013
             POP    PSW
             POP    ACC
             BN     PSW, 7, L1376      ;branch if carry clear
             OR     #$01
L1376:       ROL    
             DBNZ   B,L1358
             ROR    
             RET    

paper_L137C:       PUSH   ACC
             PUSH   B
             PUSH   C
             MOV    #$ff,B
L1385:       NOP    
             NOP    
             NOP    
             NOP    
             NOP    
             DBNZ   B,L1385
             POP    C
             POP    B
             POP    ACC
             RET    

paper_L1394:       PUSH   ACC
             PUSH   B
             PUSH   C
             MOV    #$32,B
L139D:       DBNZ   B,L139D
             POP    C
             POP    B
             POP    ACC
             RET    

L13A7:       PUSH   ACC
             PUSH   B
             PUSH   C
L13AD:       SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             CALLF   L13F1
             DBNZ   B,L13AD
             POP    C
             POP    B
             POP    ACC
             RET    

paper_L13BB:       BN     P3, 7, L13C0      ;branch if Sleep button pressed
             BR     L13C2

L13C0:       BR     paper_L13BB

L13C2:       PUSH   OCR
             MOV    #$ef,OCR
             MOV    #$00,VCCR         ;turn off LCD
             MOV    #$01,MCR
L13CD:       PUSH   P3INT
             MOV    #$05,P3INT
             SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             POP    P3INT
             BP     P7, 0, L13DC      ;branch if Dreamcast connected
             BP     P3, 7, L13CD      ;branch if Sleep button isn't pressed
L13DC:       BN     P3, 7, L13DC      ;branch if Sleep button pressed
             MOV    #$09,MCR
             MOV    #$80,VCCR         ;turn on LCD
             POP    OCR
             PUSH   P3INT
             MOV    #$05,P3INT
             SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             POP    P3INT
             RET    

L13F1:       BN     P3, 6, L13F6      ;branch if Mode button pressed
             BR     L13F9

L13F6:       BRF    paper_L10B4

L13F9:       BP     P7, 0, L13FE      ;branch if Dreamcast connected
             BR     L1401

L13FE:       BRF    paper_L10B4

L1401:       BN     P7, 1, L1406
             BR     L1408

L1406:       BR     L1410

L1408:       BN     P3, 7, L140D      ;branch if Sleep button pressed
             BR     paper_L140F

L140D:       BR     paper_L13BB

paper_L140F:       RET    

L1410:       MOV    #<paper_1e2e,TRL
             MOV    #>paper_1e2e,TRH
             CALLf   paper_L11CA
L1418:       SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             BP     P3, 6, L1418      ;branch if Mode button isn't pressed
             JMPF   quit

L1420:       BN     P3, 4, L1420      ;branch if A button pressed
L1423:       CALLF   L13F1
             PUSH   P3INT
             MOV    #$05,P3INT
             SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             POP    P3INT
             BP     P3, 4, L1423      ;branch if A button isn't pressed
             RET    

L1432:       callf   L13F1
             PUSH   P3INT
             MOV    #$05,P3INT
             SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             POP    P3INT
             BP     P3, 0, L1432      ;branch if up button isn't pressed
             RET    

L1441:       BN     P3, 4, L1441      ;branch if A button pressed
             BN     P3, 5, L1441      ;branch if B button pressed
L1447:       CALLF   L13F1
             PUSH   P3INT
             MOV    #$05,P3INT
             SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             POP    P3INT
             INC    $012
             BP     P3, 4, L1447      ;branch if A button isn't pressed
             INC    $013
             BP     P3, 5, L1447      ;branch if B button isn't pressed
             RET    

             BYTE   $03,$4c,$f1                      ;ascii ".Lq"
             BYTE   $ff,$90,$fa,$a0                  ;ascii "..z "
L1464:       CALLf   L11AA
             MOV    #<paper_14dd,TRL
             MOV    #>paper_14dd,TRH
             MOV    #$00,B
             MOV    #$09,C
             CALLf   L1166
             MOV    #$04,B
             CALLF   L13A7
             CALLf   L11AA
             MOV    #<paper_1533,TRL
             MOV    #>paper_1533,TRH
             MOV    #$01,B
             MOV    #$0d,C
             CALLf   L1166
             MOV    #$02,B
             CALLF   L13A7
             CALLf   L11AA
             MOV    #<paper_1549,TRL
             MOV    #>paper_1549,TRH
             MOV    #$00,B
             MOV    #$03,C
             CALLf   L1166
             MOV    #$01,B
             CALLF   L13A7
             MOV    #<paper_154e,TRL
             MOV    #>paper_154e,TRH
             MOV    #$00,B
             MOV    #$07,C
             CALLf   L1166
             MOV    #$01,B
             CALLF   L13A7
             MOV    #<paper_156e,TRL
             MOV    #>paper_156e,TRH
             MOV    #$00,B
             MOV    #$0d,C
             CALLf   L1166
             MOV    #$01,B
             CALLF   L13A7
             MOV    #<paper_157f,TRL
             MOV    #>paper_157f,TRH
             MOV    #$00,B
             MOV    #$15,C
             CALLf   L1166
             MOV    #$04,B
             CALLF   L13A7
             RET    

paper_14dd:
             BYTE   $06,$0e,$07
             BYTE   $fc,$00,$00,$00,$00,$18,$7f,$3c  ;ascii "|......<"
             BYTE   $70,$00,$00,$36,$7f,$ce,$76,$00  ;ascii "p..6.Nv."
             BYTE   $00,$72,$49,$ce,$ef,$00,$00,$7e  ;ascii ".rINo..~"
             BYTE   $41,$ee,$e6,$f5,$b8,$66,$49,$de  ;ascii "Anfu8fI^"
             BYTE   $ed,$d7,$ec,$6c,$99,$5d,$ed,$ee  ;ascii "mWll.]mn"
             BYTE   $ed,$21,$9c,$9f,$7f,$cc,$6e,$1f  ;ascii "m!...Ln."
             BYTE   $ff,$0e,$32,$fc,$38,$07,$fc,$00  ;ascii "..2|8.|."
             BYTE   $00,$00,$00,$00,$00,$00,$00,$62  ;ascii ".......b"
             BYTE   $22,$00,$00,$00,$00,$15,$55,$00  ;ascii "".....U."
             BYTE   $00,$00,$00,$25,$55,$00,$00,$00  ;ascii "...%U..."
             BYTE   $00,$72,$22
paper_1533:
			 BYTE	$04,$05,$66,$33,$36  ;ascii ".r"..f36"
             BYTE   $73,$55,$44,$45,$24,$66,$62,$65  ;ascii "sUDE$fbe"
             BYTE   $22,$45,$41,$45,$21,$45,$36,$35  ;ascii ""EAE!E65"
             BYTE   $26
paper_1549:
			 BYTE	$01,$03,$06,$0a,$0e
paper_154e:
			 BYTE	$06,$05  ;ascii "&......."
             BYTE   $4b,$66,$d0,$4f,$00,$00,$4a,$a5  ;ascii "KfPO..J%"
             BYTE   $46,$08,$36,$d8,$4a,$24,$55,$4b  ;ascii "F.6XJ$UK"
             BYTE   $55,$54,$4a,$24,$55,$49,$54,$58  ;ascii "UTJ$UITX"
             BYTE   $72,$24,$55,$4f,$74,$5c
paper_156e:
			 BYTE	$03,$05  ;ascii "r$UOt\.."
             BYTE   $00,$80,$00,$01,$00,$00,$01,$b7  ;ascii ".......7"
             BYTE   $6c,$01,$25,$54,$01,$27,$44
paper_157f:
			 BYTE	$06  ;ascii "l.%T.'D."
             BYTE   $07,$1e,$db,$60,$f6,$36,$f0,$1e  ;ascii "..[`v6p."
             BYTE   $db,$60,$f6,$36,$f8,$18,$db,$60  ;ascii "[`v6x.[`"
             BYTE   $66,$36,$d8,$1c,$db,$60,$66,$36  ;ascii "f6X.[`f6"
             BYTE   $d8,$18,$db,$78,$66,$b6,$d8,$1e  ;ascii "X.[xf6X."
             BYTE   $fb,$78,$67,$f6,$d8,$1e,$f3,$78  ;ascii "{xgvX.sx"
             BYTE   $67,$76,$d8                      ;ascii "gvX"
L15AB:       BP     $023, 0, L15B6
             MOV    #<paper_206e,TRL
             MOV    #>paper_206e,TRH
             jmpf    L15CB

L15B6:       BN     $023, 1, L15C3
             LD     $024
             MOV    #<paper_2078,TRL
             MOV    #>paper_2078,TRH
             jmpf    L15CB

L15C3:       SET1   $023, 1
             MOV    #<paper_206e,TRL
             MOV    #>paper_206e,TRH
L15CB:       RET    

L15CC:       PUSH   ACC
             CALLf   L118E
             MOV    #$06,B
             LD     @R0
L15D4:       ST     @R2
             INC    $002
             DBNZ   B,L15D4
             POP    ACC
             RET    

L15DD:       PUSH   ACC
             LD     $032
             ST     $031
             POP    ACC
             RET    

L15E6:       PUSH   ACC
             PUSH   B
             PUSH   C
             PUSH   XBNK
             PUSH   OCR
             MOV    #$4d,OCR
             MOV    #$1f,$000
             MOV    #$00,ACC
             CALLF   L15CC
             MOV    #$20,$000
             MOV    #$01,ACC
             CALLF   L15CC
             MOV    #$21,$000
             MOV    #$02,ACC
             CALLF   L15CC
             MOV    #$22,$000
             MOV    #$03,ACC
             CALLF   L15CC
             MOV    #$22,$000
             MOV    #$1c,ACC
             CALLF   L15CC
             MOV    #$21,$000
             MOV    #$1d,ACC
             CALLF   L15CC
             MOV    #$20,$000
             MOV    #$1e,ACC
             CALLF   L15CC
             MOV    #$1f,$000
             MOV    #$1f,ACC
             CALLF   L15CC
             LD     $01d
             BZ     L165E
L1637:       PUSH   ACC
             LD     $01e
             INC    ACC
             AND    #$03
             ST     $01e
             LD     $021
             ROL    
             ST     $021
             BN     $01e, 0, L164E
             LD     $020
             ROL    
             ST     $020
L164E:       BN     $01e, 0, L1659
             BN     $01e, 1, L1659
             LD     $01f
             ROL    
             ST     $01f
L1659:       POP    ACC
             DBNZ   ACC,L1637
L165E:       BN     $023, 0, L1664
             MOV    #$01,$025
L1664:       BN     $025, 0, L167B
             CALLF   L15AB
             MOV    #$00,B
             LD     $024
             ST     C
             CALLf   L10E6
             LD     $024
             ADD    $025
             ST     $024
             MOV    #$00,$025
L167B:       CALLF   L15AB
             MOV    #$00,B
             LD     $024
             ST     C
             CALLF   L1139
             CALLF   L1791
             BN     $02e, 0, L16C2
             DBNZ   $031,L16C2
             CALLF   L15DD
             BP     $02e, 1, L16A3
             LD     $02f
             ST     B
             LD     $030
             ST     C
             MOV    #<paper_209c,TRL
             MOV    #>paper_209c,TRH
             CALLf   L10E6
L16A3:       CLR1   $02e, 1
             LD     $02f
             INC    ACC
             ST     $02f
             BNE    #$06,L16B2
             CLR1   $02e, 0
             jmpf    L16C2

L16B2:       LD     $02f
             ST     B
             LD     $030
             ST     C
             MOV    #<paper_209c,TRL
             MOV    #>paper_209c,TRH
             CALLf   L1139
L16C2:       POP    OCR
             POP    XBNK
             POP    C
             POP    B
             POP    ACC
             RET    

L16CD:       BP     $049, 1, L16FD
             BP     $04a, 0, L16E8
             BP     $04a, 1, L16E0
             jmpf    L16D8

L16D8:       MOV    #<paper_209f,TRL
             MOV    #>paper_209f,TRH
             jmpf    L1752

L16E0:       MOV    #<paper_20b3,TRL
             MOV    #>paper_20b3,TRH
             jmpf    L1752

L16E8:       BP     $04a, 1, L16F5
             jmpf    L16ED

L16ED:       MOV    #<paper_20a9,TRL
             MOV    #>paper_20a9,TRH
             jmpf    L1752

L16F5:       MOV    #<paper_20bd,TRL
             MOV    #>paper_20bd,TRH
             jmpf    L1752

L16FD:       BP     $04a, 0, L1729
             BP     $04a, 1, L1716
             BP     $04a, 2, L170E
             MOV    #<paper_20c7,TRL
             MOV    #>paper_20c7,TRH
             jmpf    L1752

L170E:       MOV    #<paper_20ef,TRL
             MOV    #>paper_20ef,TRH
             jmpf    L1752

L1716:       BP     $04a, 2, L1721
             MOV    #<paper_20db,TRL
             MOV    #>paper_20db,TRH
             jmpf    L1752

L1721:       MOV    #<paper_2103,TRL
             MOV    #>paper_2103,TRH
             jmpf    L1752

L1729:       BP     $04a, 1, L173F
             BP     $04a, 2, L1737
             MOV    #<paper_20d1,TRL
             MOV    #>paper_20d1,TRH
             jmpf    L1752

L1737:       MOV    #<paper_20f9,TRL
             MOV    #>paper_20f9,TRH
             jmpf    L1752

L173F:       BP     $04a, 2, L174A
             MOV    #<paper_20e5,TRL
             MOV    #>paper_20e5,TRH
             jmpf    L1752

L174A:       MOV    #<paper_2103,TRL
             MOV    #>paper_2103,TRH
             jmpf    L1752

L1752:       RET    

L1753:       DBNZ   $04d,L1790
             LD     $038
             ST     $04d
             LD     $04e
             INC    ACC
             AND    #$03
             ST     $04e
             ROL    
             ROL    
             ADD    #$39
             ST     $000
             LD     @R0
             BP     ACC, 0, L1790
             SET1   ACC, 0
             CLR1   ACC, 1
             SET1   ACC, 2
             ST     @R0
             INC    $000
             CALLf   L134E
             AND    #$03
             OR     $04f
             ST     @R0
             INC    $000
             MOV    #$06, @R0
             INC    $000
             CALLf   L134E
             ST     C
             MOV    #$00,ACC
             MOV    #$1a,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             LD     B
             ST     @R0
L1790:       RET    

L1791:       LD     $015
             BE     #$04,L179B
             BN     PSW, 7, L179B      ;branch if carry clear
             CALLF   L1753
L179B:       MOV    #$39,$000
             MOV    #$04,B
L17A1:       PUSH   B
             LD     $000
             ADD    #$02
             ST     $001
             LD     @R0
             ST     $049
             INC    $000
             BN     ACC, 0, L17B3
             BR     L17B6

L17B3:       BRF    L1896

L17B6:       LD     @R0
             ST     $04a
             LD     @R1
             ST     $04b
             INC    $001
             LD     @R1
             ST     $04c
             BP     $049, 1, L17DA
             LD     $04b
             BE     #$02,L17C9
L17C9:       BN     PSW, 7, L17DA      ;branch if carry clear
             LD     $04c
             SUB    $024
             ADD    #$06
             BE     #$09,L17D5
L17D5:       BN     PSW, 7, L17DA      ;branch if carry clear
             SET1   $023, 0
L17DA:       BN     $02e, 0, L1810
             BP     $049, 1, L1810
             BP     $049, 3, L1810
             LD     $04b
             BE     #$06,L1810
             LD     $04b
             BE     $02f,L17F0
             BN     PSW, 7, L1810      ;branch if carry clear
L17F0:       LD     $030
             SUB    $04c
             BE     #$08,L17F7
L17F7:       BN     PSW, 7, L1810      ;branch if carry clear
             INC    $010
             SET1   $049, 3
             CLR1   $02e, 0
             LD     $02f
             ST     B
             LD     $030
             ST     C
             MOV    #<paper_209c,TRL
             MOV    #>paper_209c,TRH
             CALLf   L10E6
L1810:       LD     $04a
             SUB    #$10
             ST     $04a
             AND    #$f0
             BN     $049, 1, L1829
             BN     ACC, 5, paper_L1880
             BN     ACC, 5, paper_L1880
             LD     $04a
             AND    #$07
             ST     $04a
             jmpf    L182B

L1829:       BNZ    paper_L1880
L182B:       LD     $04b
             BE     #$06,L183A
             ST     B
             LD     $04c
             ST     C
             CALLF   L16CD
             CALLF   L10E6
L183A:       BN     $049, 3, L1844
             CLR1   $049, 3
             SET1   $049, 1
             MOV    #$07,$04a
L1844:       LD     $04a
             OR     $04f
             ADD    #$01
             AND    #$f7
             ST     $04a
             BN     $049, 1, paper_L185F
             SET1   $049, 2
             LD     $04a
             AND    #$07
             XOR    #$07
             BNZ    L186F
             CLR1   $049, 0
             jmpf    L186F

paper_L185F:       LD     $04b
             BZ     L186B
             DEC    ACC
             ST     $04b
             SET1   $049, 2
             jmpf    L186F

L186B:       CLR1   $049, 0
             jmpf    L186F

L186F:       BPC    $049, 2, L1874
             jmpf    paper_L1880

L1874:       LD     $04b
             ST     B
             LD     $04c
             ST     C
             CALLF   L16CD
             CALLF   L1139
paper_L1880:       DEC    $000
             LD     $049
             ST     @R0
             INC    $000
             LD     $04a
             ST     @R0
             INC    $000
             LD     $04b
             ST     @R0
             INC    $000
             LD     $04c
             ST     @R0
             jmpf    L189A

L1896:       INC    $000
             INC    $000
L189A:       INC    $000
             POP    B
             DBNZ   B,L18A3
             BR     L18A6

L18A3:       BRF    L17A1

L18A6:       RET    

L18A7:       MOV    #$39,$000
             MOV    #$10,B
L18AD:       MOV    #$00, @R0
             INC    $000
             DBNZ   B,L18AD
             RET    

L18B5:       MOV    #$39,$000
             MOV    #$04,B
L18BB:       LD     @R0
             SET1   ACC, 3
             ST     @R0
             INC    $000
             INC    $000
             INC    $000
             MOV    #$04, @R0
             INC    $000
             DBNZ   B,L18BB
             RET    

L18CD:       LD     $010
             ST     $011
             BE     #$3c,paper_L18D4
paper_L18D4:       BP     PSW, 7, L18DA      ;branch if carry set
             MOV    #$3c,$011
L18DA:       LD     $011
             ST     C
             MOV    #$03,B
             MOV    #$00,ACC
             DIV                         ; ACC:C remainder B <- ACC:C / B
             LD     C
             ST     $011
             BZ     L191F
             MOV    #$05,B
             MOV    #$19,C
L18F1:       BP     C, 0, L18FC
             MOV    #<paper_210d,TRL
             MOV    #>paper_210d,TRH
             jmpf    L1902

L18FC:       MOV    #<paper_2110,TRL
             MOV    #>paper_2110,TRH
L1902:       PUSH   ACC
             PUSH   B
             PUSH   C
             CALLF   L1139
             POP    C
             POP    B
             POP    ACC
             DEC    C
             CALLF   paper_L1394
             DBNZ   $011,L18F1
             MOV    #<paper_2113,TRL
             MOV    #>paper_2113,TRH
             CALLF   L1139
L191F:       CALLF   L1420
             CALLF   L1924
             RET    

L1924:       MOV    #<paper_21f2,TRL
             MOV    #>paper_21f2,TRH
             CALLF   paper_L11CA
             BP     $014, 0, L1937
             MOV    #<paper_22b2,TRL
             MOV    #>paper_22b2,TRH
             JMPf    L193D

L1937:       MOV    #<paper_22c2,TRL
             MOV    #>paper_22c2,TRH
L193D:       MOV    #$04,B
             MOV    #$06,C
             CALLF   L1139
             MOV    #$01,B
             MOV    #$10,C
             PUSH   $010
             CALLF   L196D
             POP    $010
             CALLF   L1420
             RET    

L1954:       MOV    #<paper_19ca,TRL
             MOV    #>paper_19ca,TRH
             BZ     L196C
             ST     B
L195E:       LD     TRL
             ADD    #$0d
             ST     TRL
             BN     PSW, 7, L1969      ;branch if carry clear
             INC    TRH
L1969:       DBNZ   B,L195E
L196C:       RET    

L196D:       PUSH   B
             PUSH   C
             LD     $010
             ST     C
             MOV    #$00,ACC
             MOV    #$64,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             LD     B
             ST     $010
             LD     C
             CALLF   L1954
             POP    C
             POP    B
             PUSH   B
             PUSH   C
             CALLF   L1166
             POP    C
             POP    B
             INC    B
             PUSH   B
             PUSH   C
             LD     $010
             ST     C
             MOV    #$00,ACC
             MOV    #$0a,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             LD     B
             ST     $010
             LD     C
             CALLF   L1954
             POP    C
             POP    B
             PUSH   B
             PUSH   C
             CALLF   L1166
             POP    C
             POP    B
             INC    B
             LD     $010
             PUSH   B
             PUSH   C
             CALLF   L1954
             POP    C
             POP    B
             CALLF   L1166
             RET    

paper_19ca:
             BYTE   $01,$0b,$7c,$fe,$c6,$c6          ;ascii "..|~FF"
             BYTE   $c6,$c6,$c6,$c6,$c6,$fe,$7c,$01  ;ascii "FFFFF~|."
             BYTE   $0b,$0c,$1c,$3c,$7c,$6c,$0c,$0c  ;ascii "...<|l.."
             BYTE   $0c,$0c,$0c,$0c,$01,$0b,$7c,$fe  ;ascii "......|~"
             BYTE   $c6,$c6,$0e,$0c,$1c,$38,$70,$fe  ;ascii "FF...8p~"
             BYTE   $fe,$01,$0b,$fc,$fe,$06,$06,$3c  ;ascii "~..|~..<"
             BYTE   $3c,$06,$06,$06,$fe,$fc,$01,$0b  ;ascii "<...~|.."
             BYTE   $18,$18,$38,$30,$70,$60,$ec,$cc  ;ascii "..80p`lL"
             BYTE   $fe,$fe,$0c,$01,$0b,$fe,$fe,$c0  ;ascii "~~...~~@"
             BYTE   $c0,$fc,$fe,$06,$06,$06,$fe,$fc  ;ascii "@|~...~|"
             BYTE   $01,$0b,$3e,$7e,$e0,$c0,$fc,$fe  ;ascii "..>~`@|~"
             BYTE   $c6,$c6,$c6,$fe,$7c,$01,$0b,$fe  ;ascii "FFF~|..~"
             BYTE   $fe,$06,$06,$0e,$0c,$1c,$18,$38  ;ascii "~......8"
             BYTE   $70,$60,$01,$0b,$7c,$fe,$c6,$c6  ;ascii "p`..|~FF"
             BYTE   $7c,$fe,$c6,$c6,$c6,$fe,$7c,$01  ;ascii "|~FFF~|."
             BYTE   $0b,$7c,$fe,$c6,$c6,$c6,$fe,$7e  ;ascii ".|~FFF~~"
             BYTE   $06,$0e,$fc,$f8                  ;ascii "..|x"
L1A4C:       LD     $01b
             BZ     paper_L1A7E
             DEC    $01b
             MOV    #$05,ACC
             MOV    #$01,B
             MOV    #$05,C
L1A5B:       MOV    #<paper_21da,TRL
             MOV    #>paper_21da,TRH
             PUSH   ACC
             PUSH   B
             PUSH   C
             CALLF   L1139
             CALLF   paper_L1394
             CALLF   paper_L1394
             CALLF   paper_L1394
             POP    C
             POP    B
             POP    ACC
             INC    B
             DBNZ   ACC,L1A5B
             CALLF   L11AA
             CALLF   L18A7
paper_L1A7E:       RET    

L1A7F:       LD     $015
             BNE    #$00,L1A86
             BR     L1AA8

L1A86:       BNE    #$01,L1A8B
             BR     L1AC1

L1A8B:       BNE    #$02,L1A90
             BR     L1ADA

L1A90:       BNE    #$03,paper_L1A95
             BR     paper_L1AF5

paper_L1A95:       BNE    #$04,L1A9B
             BRF    L1B1D

L1A9B:       BNE    #$05,L1AA1
             BRF    paper_L1C6E

L1AA1:       BNE    #$06,L1AA7
             BRF    L1C88

L1AA7:       RET    

L1AA8:       LD     $010
             BNE    #$0a,paper_L1AAD
paper_L1AAD:       BP     PSW, 7, L1AC0      ;branch if carry set
             INC    $015
             DEC    $032
             LD     $04f
             SUB    #$20
             ST     $04f
             LD     $038
             SUB    #$06
             ST     $038
L1AC0:       RET    

L1AC1:       LD     $010
             BNE    #$1c,paper_L1AC6
paper_L1AC6:       BP     PSW, 7, L1AD9      ;branch if carry set
             INC    $015
             DEC    $032
             LD     $04f
             SUB    #$20
             ST     $04f
             LD     $038
             SUB    #$06
             ST     $038
L1AD9:       RET    

L1ADA:       LD     $010
             BNE    #$30,L1ADF
L1ADF:       BP     PSW, 7, L1AF4      ;branch if carry set
             INC    $015
             DEC    $032
             INC    $01d
             LD     $04f
             SUB    #$20
             ST     $04f
             LD     $038
             SUB    #$04
             ST     $038
L1AF4:       RET    

paper_L1AF5:       LD     $010
             BNE    #$3c,L1AFA
L1AFA:       BP     PSW, 7, L1B1C      ;branch if carry set
             INC    $015
             INC    $01d
             MOV    #$16,$016
             MOV    #$01,$017
             MOV    #$0c,$018
             MOV    #$06,$01a
             MOV    #$ff,$019
             MOV    #$00,$01b
             CALLF   L18A7
             CALLF   L11AA
             CALLF   L1D04
             MOV    #$00,$01d
L1B1C:       RET    

L1B1D:       BP     $017, 0, L1B74
             BN     $02e, 0, L1B74
             LD     $02f
             BNE    #$04,L1B74
             LD     $030
             SUB    #$0d
             BNE    #$04,paper_L1B2F
paper_L1B2F:       BN     PSW, 7, L1B74      ;branch if carry clear
             LD     $016
             BZ     paper_L1B58
             DEC    $016
             INC    $010
             MOV    #<paper_21b2,TRL
             MOV    #>paper_21b2,TRH
             MOV    #$04,B
             MOV    #$08,C
             CALLF   L10E6
             MOV    #<paper_21b7,TRL
             MOV    #>paper_21b7,TRH
             MOV    #$04,B
             MOV    #$08,C
             CALLF   L1139
             jmpf    L1B74

paper_L1B58:       MOV    #<paper_21d3,TRL
             MOV    #>paper_21d3,TRH
             LD     $019
             ST     B
             MOV    #$0c,C
             CALLF   L10E6
             CALLF   L1CF5
             CALLF   L1D13
             MOV    #$64,$018
             INC    $015
             CLR1   $02e, 0
             jmpf    L1C6D

L1B74:       LD     $019
             DEC    ACC
             BNZ    L1B97
             LD     $024
             SUB    #$0c
             ADD    #$04
             BE     #$08,L1B83
L1B83:       BN     PSW, 7, L1B97      ;branch if carry clear
             SET1   $023, 0
             MOV    #<paper_21d3,TRL
             MOV    #>paper_21d3,TRH
             LD     $019
             ST     B
             MOV    #$0c,C
             CALLF   L10E6
L1B97:       DBNZ   $01a,L1B9C
             BR     L1B9E

L1B9C:       BR     L1BFF

L1B9E:       LD     $019
             BZ     L1BF0
             XOR    #$ff
             BZ     L1BFF
             MOV    #$06,$01a
             MOV    #<paper_21d3,TRL
             MOV    #>paper_21d3,TRH
             LD     $019
             ST     B
             MOV    #$0c,C
             CALLF   L10E6
             DEC    $019
             LD     $019
             MOV    #<paper_21d3,TRL
             MOV    #>paper_21d3,TRH
             LD     $019
             ST     B
             MOV    #$0c,C
             CALLF   L1139
             LD     $019
             BNE    #$03,L1BFF
             CALLF   L1D04
             MOV    #<paper_21bc,TRL
             MOV    #>paper_21bc,TRH
             MOV    #$04,B
             MOV    #$0d,C
             CALLF   L10E6
             MOV    #<paper_21c4,TRL
             MOV    #>paper_21c4,TRH
             MOV    #$04,B
             MOV    #$0d,C
             CALLF   L1139
             jmpf    L1BFF

L1BF0:       MOV    #<paper_21d3,TRL
             MOV    #>paper_21d3,TRH
             LD     $019
             ST     B
             MOV    #$0c,C
             CALLF   L10E6
L1BFF:       DBNZ   $018,L1C04
             BR     L1C06

L1C04:       BR     L1C6D

L1C06:       NOT1   $017, 0
             BP     $017, 0, L1C32
             MOV    #$0c,$018
             MOV    #<paper_21bc,TRL
             MOV    #>paper_21bc,TRH
             MOV    #$04,B
             MOV    #$0d,C
             CALLF   L10E6
             MOV    #<paper_21c4,TRL
             MOV    #>paper_21c4,TRH
             MOV    #$04,B
             MOV    #$0d,C
             CALLF   L1139
             MOV    #$04,$019
             MOV    #$01,$01a
             jmpf    L1C6D

L1C32:       MOV    #<paper_21b7,TRL
             MOV    #>paper_21b7,TRH
             MOV    #$04,B
             MOV    #$08,C
             CALLF   L10E6
             MOV    #<paper_21b2,TRL
             MOV    #>paper_21b2,TRH
             MOV    #$04,B
             MOV    #$08,C
             CALLF   L1139
             MOV    #$24,$018
             MOV    #<paper_21c4,TRL
             MOV    #>paper_21c4,TRH
             MOV    #$04,B
             MOV    #$0d,C
             CALLF   L10E6
             MOV    #<paper_21bc,TRL
             MOV    #>paper_21bc,TRH
             MOV    #$04,B
             MOV    #$0d,C
             CALLF   L1139
L1C6D:       RET    

paper_L1C6E:       LD     $024
             BNE    #$0c,L1C75
             BR     L1C80

L1C75:       BP     PSW, 7, L1C7D      ;branch if carry set
             MOV    #$ff,$025
             jmpf    L1C80

L1C7D:       MOV    #$01,$025
L1C80:       DBNZ   $018,L1C87
             INC    $015
             SET1   $014, 0
L1C87:       RET    

L1C88:       LD     $01b
             ST     C
             MOV    #$00,ACC
             MOV    #$04,B
             MUL                         ; B:ACC:C <- ACC:C * B
             LD     C
             ADD    $010
             ADD    #$08
             ST     $010
             PUSH   P3INT
             MOV    #$05,P3INT
             SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             POP    P3INT
             MOV    #<paper_1fae,TRL
             MOV    #>paper_1fae,TRH
             CALLF   paper_L11CA
             MOV    #<paper_2088,TRL
             MOV    #>paper_2088,TRH
             MOV    #$08,ACC
             MOV    #$00,B
             MOV    #$0c,C
L1CBB:       PUSH   ACC
             PUSH   B
             PUSH   C
             CALLF   L10E6
             POP    C
             POP    B
             POP    ACC
             INC    C
             PUSH   ACC
             PUSH   B
             PUSH   C
             CALLF   L1139
             POP    C
             POP    B
             POP    ACC
             CALLF   paper_L1394
             CALLF   paper_L1394
             CALLF   paper_L1394
             DBNZ   ACC,L1CBB
             PUSH   P3INT
             MOV    #$05,P3INT
             SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             POP    P3INT
             CALLF   L18CD
             CALLF   L1420
             POP    ACC
             POP    ACC
             JMPf    paper_L1006

L1CF5:       MOV    #$02,B
             MOV    #$05,C
             MOV    #<paper_2116,TRL
             MOV    #>paper_2116,TRH
             CALLF   L10E6
             RET    

L1D04:       MOV    #$02,B
             MOV    #$05,C
             MOV    #<paper_2116,TRL
             MOV    #>paper_2116,TRH
             CALLF   L1139
             RET    

L1D13:       MOV    #<paper_2174,TRL
             MOV    #>paper_2174,TRH
             MOV    #$03,B
             MOV    #$08,C
             CALLF   L1139
             RET    

L1D22:       BN     P3, 4, L1D22      ;branch if A button pressed
             MOV    #<paper_22d2,TRL
             MOV    #>paper_22d2,TRH
             CALLF   paper_L11CA
             MOV    #$00,ACC
L1D30:       PUSH   ACC
             BNE    #$00,L1D45
             MOV    #<paper_2392,TRL
             MOV    #>paper_2392,TRH
             MOV    #$02,B
             MOV    #$07,C
             CALLF   L1166
             jmpf    L1D56

L1D45:       BNE    #$04,L1D56
             MOV    #<paper_23f8,TRL
             MOV    #>paper_23f8,TRH
             MOV    #$02,B
             MOV    #$07,C
             CALLF   L1166
L1D56:       CALLF   L13F1
             PUSH   P3INT
             MOV    #$05,P3INT
             SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             POP    P3INT
             POP    ACC
             INC    ACC
             AND    #$07
             BP     P3, 4, L1D30      ;branch if A button isn't pressed
L1D6A:       BN     P3, 4, L1D6A      ;branch if A button pressed
             RET    

paper_1d6e:
             BYTE   $00,$00
             BYTE   $07,$81,$e1,$ff,$67,$77,$77,$c9  ;ascii "..a.gwwI"
             BYTE   $b1,$03,$55,$54,$46,$dd,$f2,$05  ;ascii "1.UTF]r."
             BYTE   $66,$63,$37,$c9,$b2,$09,$45,$77  ;ascii "fc7I2.Ew"
             BYTE   $76,$c1,$f4,$11,$00,$00,$00,$00  ;ascii "vAt....."
             BYTE   $04,$21,$ff,$ff,$ff,$ff,$e8,$41  ;ascii ".!....hA"
             BYTE   $80,$00,$00,$00,$08,$81,$bc,$73  ;ascii "......<s"
             BYTE   $cf,$bc,$11,$03,$a2,$8a,$28,$a2  ;ascii "O<..".(""
             BYTE   $12,$0c,$aa,$aa,$ab,$aa,$24,$31  ;ascii "..**+*$1"
             BYTE   $a2,$8a,$29,$22,$28,$c1,$ac,$aa  ;ascii "".)"(A,*"
             BYTE   $cb,$a9,$53,$01,$a8,$aa,$88,$ad  ;ascii "K)S.(*.-"
             BYTE   $6c,$61,$b8,$fb,$8f,$bb,$70,$e1  ;ascii "la8{.;pa"
             BYTE   $80,$00,$00,$00,$00,$ed,$80,$1e  ;ascii ".....m.."
             BYTE   $78,$00,$01,$dd,$86,$7f,$fe,$30  ;ascii "x..]..~0"
             BYTE   $e1,$f9,$9f,$6c,$36,$f9,$c1,$f1  ;ascii "ay.l6yAq"
             BYTE   $9b,$4e,$b2,$d9,$83,$f9,$b3,$1c  ;ascii ".N2Y.y3."
             BYTE   $39,$99,$8b,$fd,$bf,$9d,$39,$fd  ;ascii "9..}?.9}"
             BYTE   $fb,$bd,$bf,$dc,$39,$fe,$fb,$1d  ;ascii "{=?\9~{."
             BYTE   $81,$8b,$d0,$0c,$73,$09,$80,$00  ;ascii "..P.s..."
             BYTE   $00,$00,$00,$01,$ff,$ff,$ff,$ff
             BYTE   $ff,$ff,$00,$00,$00,$00,$00,$00
             BYTE   $49,$00,$40,$00,$62,$22,$b4,$65  ;ascii "I.@.b"4e"
             BYTE   $6c,$ee,$15,$55,$a5,$55,$4a,$aa  ;ascii "ln.U%UJ*"
             BYTE   $25,$55,$b5,$55,$4c,$ca,$45,$55  ;ascii "%U5ULJEU"
             BYTE   $49,$57,$6e,$ae,$72,$22
paper_1e2e:
			 BYTE	$00,$00  ;ascii "IWn.r".."
             BYTE   $00,$00,$00,$00,$00,$00,$00,$00
             BYTE   $00,$00,$80,$00,$38,$00,$00,$00  ;ascii "....8..."
             BYTE   $83,$22,$24,$ce,$ee,$e9,$84,$a2  ;ascii "."$Nni.""
             BYTE   $3d,$24,$48,$a7,$84,$aa,$25,$e4  ;ascii "=$H'.*%d"
             BYTE   $4c,$c1,$f3,$14,$3d,$24,$4e,$ae  ;ascii "LAs.=$N."
             BYTE   $00,$00,$00,$00,$00,$00,$07,$83
             BYTE   $c0,$03,$c1,$e0,$08,$44,$20,$84  ;ascii "@.A`.D ."
             BYTE   $22,$10,$14,$aa,$57,$ca,$55,$28  ;ascii ""..*WJU("
             BYTE   $10,$28,$17,$e8,$14,$08,$13,$29  ;ascii ".(.h...)"
             BYTE   $97,$ea,$55,$28,$14,$aa,$57,$c9  ;ascii ".jU(.*WI"
             BYTE   $94,$c8,$08,$44,$20,$84,$22,$10  ;ascii ".H.D ."."
             BYTE   $07,$83,$c0,$03,$c1,$e0,$60,$00  ;ascii "..@.A``."
             BYTE   $00,$00,$00,$00,$54,$73,$1b,$84  ;ascii "....Ts.."
             BYTE   $00,$00,$64,$44,$a2,$0f,$ff,$fc  ;ascii "..dD"..|"
             BYTE   $44,$67,$9b,$04,$00,$04,$47,$74  ;ascii "Dg....Gt"
             BYTE   $bb,$80,$00,$04,$00,$00,$00,$00  ;ascii ";......."
             BYTE   $00,$04,$20,$3b,$b2,$18,$dc,$04  ;ascii ".. ;2.\."
             BYTE   $20,$2a,$2a,$25,$10,$04,$20,$33  ;ascii " **%.. 3"
             BYTE   $32,$3d,$18,$04,$20,$2b,$a3,$a4  ;ascii "2=.. +#$"
             BYTE   $dc,$00,$20,$00,$00,$00,$00,$00  ;ascii "\. ....."
             BYTE   $20,$00,$00,$07,$4b,$b6,$20,$00  ;ascii " ...K6 ."
             BYTE   $00,$82,$7a,$2a,$3f,$ff,$ff,$c2  ;ascii "..z*?..B"
             BYTE   $4b,$22,$00,$00,$00,$82,$4b,$a2  ;ascii "K"....K""
             BYTE   $00,$00,$00,$00,$00,$00
paper_1eee:
			 BYTE	$06,$04
             BYTE   $00,$00,$00,$1a,$18,$02,$00,$00
             BYTE   $00,$35,$20,$01,$00,$00,$00,$2d  ;ascii ".5 ....-"
             BYTE   $18,$00,$80,$83,$e0,$3a,$24,$0e  ;ascii "....`:$."
             BYTE   $59,$cf,$e0,$00,$40,$1f,$1f,$ef  ;ascii "YO`.@..o"
             BYTE   $c0,$3f,$4f,$3b,$bf,$e7,$00,$21  ;ascii "@?O;?g.!"
             BYTE   $1f,$3f,$bf,$f7,$c0,$21,$3f,$3b  ;ascii ".??w@!?;"
             BYTE   $bb,$73,$80,$21,$38,$39,$b8,$7b  ;ascii ";s.!898{"
             BYTE   $f0,$21,$3b,$d9,$b9,$3b,$f8,$21  ;ascii "p!;Y9;x!"
             BYTE   $39,$e0,$00,$80,$f8,$21,$3f,$e0  ;ascii "9`..x!?`"
             BYTE   $c0,$40,$00,$21,$3f,$c0,$30,$20  ;ascii "@@.!?@0 "
             BYTE   $1c,$21,$1f,$80,$0c,$10,$64,$21  ;ascii ".!....d!"
             BYTE   $0e,$20,$03,$08,$88,$21,$00,$1c  ;ascii ". ...!.."
             BYTE   $00,$c7,$08,$21,$00,$03,$80,$04  ;ascii ".G.!...."
             BYTE   $10,$21,$00,$00,$78,$08,$20,$21  ;ascii ".!..x. !"
             BYTE   $07,$c0,$07,$00,$40,$21,$1f,$e0  ;ascii ".@..@!.`"
             BYTE   $00,$e0,$80,$21,$3d,$f7,$0e,$1f  ;ascii ".`.!=w.."
             BYTE   $6e,$21,$70,$f7,$8e,$00,$ff,$21  ;ascii "n!pw...!"
             BYTE   $70,$f7,$9e,$78,$ff,$a1,$70,$f7  ;ascii "pw.x.!pw"
             BYTE   $9c,$fc,$f1,$a1,$70,$e7,$bd,$cc  ;ascii ".|q!pg=L"
             BYTE   $78,$21,$70,$e3,$f9,$f8,$38,$3f  ;ascii "x!pcyx8?"
             BYTE   $39,$c3,$f1,$e1,$bc,$00,$3f,$81  ;ascii "9Cqa<.?."
             BYTE   $e1,$ff,$bc,$0c,$1f,$00,$c0,$ff  ;ascii "a.<...@."
             BYTE   $00,$12,$00,$00,$00,$3e,$00,$12  ;ascii ".....>.."
             BYTE   $00,$00,$00,$00,$00,$0c
paper_1fae:
			 BYTE	$89,$a2  ;ascii ".......""
             BYTE   $0c,$44,$65,$1a,$aa,$22,$0a,$aa  ;ascii ".De.*".*"
             BYTE   $85,$35,$ab,$22,$0a,$aa,$c5,$2d  ;ascii ".5+".*E-"
             BYTE   $aa,$22,$0a,$aa,$80,$3a,$51,$99  ;ascii "*".*.:Q."
             BYTE   $8c,$4a,$65,$00,$00,$00,$00,$00  ;ascii ".Je....."
             BYTE   $00,$3f,$7f,$ff,$ff,$ff,$ff,$a1  ;ascii ".?.....!"
             BYTE   $70,$00,$00,$00,$03,$a1,$60,$60  ;ascii "p....!``"
             BYTE   $1b,$00,$01,$a1,$60,$90,$04,$00  ;ascii "...!`..."
             BYTE   $01,$a1,$40,$93,$60,$1f,$fe,$a1  ;ascii ".!@.`.~!"
             BYTE   $40,$60,$80,$35,$54,$a1,$40,$00  ;ascii "@`.5T!@."
             BYTE   $00,$6a,$aa,$a1,$00,$00,$00,$55  ;ascii ".j*!...U"
             BYTE   $55,$21,$00,$00,$00,$6a,$aa,$a1  ;ascii "U!...j*!"
             BYTE   $00,$00,$00,$7f,$ff,$a1,$00,$00  ;ascii ".....!.."
             BYTE   $00,$20,$00,$21,$00,$00,$00,$27  ;ascii ". .!...'"
             BYTE   $00,$21,$00,$00,$00,$67,$00,$21  ;ascii ".!...g.!"
             BYTE   $00,$00,$00,$73,$00,$21,$00,$00  ;ascii "...s.!.."
             BYTE   $00,$3f,$e0,$21,$00,$00,$00,$2f  ;ascii ".?`!.../"
             BYTE   $f0,$21,$00,$00,$00,$23,$d8,$21  ;ascii "p!...#X!"
             BYTE   $00,$00,$00,$23,$d8,$21,$00,$00  ;ascii "...#X!.."
             BYTE   $00,$23,$c0,$21,$5f,$ff,$ff,$ff  ;ascii ".#@!_..."
             BYTE   $fe,$a1,$47,$ff,$f0,$03,$60,$bf  ;ascii "~!G.p.`?"
             BYTE   $4f,$ff,$80,$03,$60,$80,$6f,$fe  ;ascii "O...`.o~"
             BYTE   $00,$03,$61,$8c,$60,$00,$00,$03  ;ascii "..a.`..."
             BYTE   $61,$92,$70,$00,$00,$00,$03,$92  ;ascii "a.p....."
             BYTE   $7f,$ff,$ff,$ff,$ff,$8c
paper_206e:
			 BYTE	$02,$04
             BYTE   $07,$e0,$08,$58,$07,$86,$07,$ff  ;ascii ".`.X...."
paper_2078:
             BYTE   $02,$07,$00,$e0,$03,$10,$04,$f8  ;ascii "...`...x"
             BYTE   $03,$04,$00,$c2,$00,$39,$00,$07  ;ascii "...B.9.."
paper_2088:
             BYTE   $03,$06,$0f,$c0,$00,$10,$38,$00  ;ascii "...@..8."
             BYTE   $10,$46,$00,$1f,$81,$80,$08,$00  ;ascii ".F......"
             BYTE   $60,$07,$ff,$f0
paper_209c:
			 BYTE	$01,$01,$b8
paper_209f:
			 BYTE	$01  ;ascii "`..p..8."
             BYTE   $08,$00,$18,$26,$49,$42,$34,$08  ;ascii "...&IB4."
             BYTE   $00
paper_20a9:
			 BYTE	$01,$08,$00,$18,$24,$22,$4a  ;ascii ".....$"J"
             BYTE   $24,$14,$08
paper_20b3:
			 BYTE	$01,$08,$00,$10,$2c  ;ascii "$......,"
             BYTE   $42,$92,$64,$18,$00
paper_20bd:
			 BYTE	$01,$08,$10  ;ascii "B.d....."
             BYTE   $28,$24,$52,$44,$24,$18,$00
paper_20c7:
			 BYTE	$01  ;ascii "($RD$..."
             BYTE   $08,$00,$70,$88,$c4,$24,$48,$30  ;ascii "..p.D$H0"
             BYTE   $00
paper_20d1:
			 BYTE	$01,$08,$10,$2c,$42,$54,$22  ;ascii "....,BT""
             BYTE   $24,$18,$00
paper_20db:
			 BYTE	$01,$08,$10,$28,$24  ;ascii "$.....($"
             BYTE   $18,$06,$09,$0a,$04
paper_20e5:
			 BYTE	$01,$08,$08
             BYTE   $14,$14,$08,$04,$0a,$05,$02
paper_20ef:
			 BYTE	$01
             BYTE   $08,$04,$0a,$04,$00,$00,$02,$05
             BYTE   $02
paper_20f9:
			 BYTE	$01,$08,$00,$04,$00,$00,$00
             BYTE   $00,$02,$00
paper_2103:
			 BYTE	$01,$08,$00,$00,$00
             BYTE   $00,$00,$00,$00,$00
paper_210d:
			 BYTE	$01,$01,$0a
paper_2110:
             BYTE   $01,$01,$14
paper_2113:
			 BYTE	$01,$01,$1e
paper_2116:
			 BYTE	$04,$17
             BYTE   $00,$00,$00,$78,$00,$00,$01,$84  ;ascii "...x...."
             BYTE   $00,$00,$02,$02,$00,$00,$06,$1a
             BYTE   $00,$00,$05,$0a,$00,$00,$06,$11
             BYTE   $00,$00,$08,$01,$00,$00,$0c,$03
             BYTE   $00,$00,$07,$84,$00,$00,$04,$4b  ;ascii ".......K"
             BYTE   $00,$00,$04,$14,$00,$00,$03,$68  ;ascii ".......h"
             BYTE   $00,$00,$00,$b0,$00,$00,$80,$e0  ;ascii "...0...`"
             BYTE   $00,$01,$40,$a0,$00,$01,$43,$20  ;ascii "..@ ..C "
             BYTE   $00,$02,$9c,$40,$00,$0e,$e1,$80  ;ascii "...@..a."
             BYTE   $00,$13,$fe,$00,$00,$3d,$00,$00  ;ascii "..~..=.."
             BYTE   $00,$c5,$00,$00,$01,$35,$00,$00  ;ascii ".E...5.."
             BYTE   $02,$cf,$ff,$ff
paper_2174:
			 BYTE	$03,$14,$00,$0f  ;ascii ".O......"
             BYTE   $00,$00,$30,$c0,$00,$40,$a0,$00  ;ascii "..0@.@ ."
             BYTE   $81,$50,$00,$80,$48,$00,$90,$08  ;ascii ".P..H..."
             BYTE   $00,$a8,$04,$00,$70,$0b,$00,$21  ;ascii ".(..p..!"
             BYTE   $94,$00,$2e,$68,$00,$1b,$b0,$00  ;ascii "...h..0."
             BYTE   $60,$e0,$00,$a7,$40,$01,$58,$80  ;ascii "``.'@.X."
             BYTE   $0e,$e3,$00,$13,$fc,$00,$3d,$00  ;ascii ".c..|.=."
             BYTE   $00,$45,$00,$00,$95,$00,$00,$af  ;ascii ".E...../"
             BYTE   $ff,$ff
paper_21b2:
			 BYTE	$01,$03,$06,$05,$06
paper_21b7:
			 BYTE	$01
             BYTE   $03,$1e,$21,$1e
paper_21bc:
			 BYTE	$02,$03,$07,$80  ;ascii "..!....."
             BYTE   $04,$40,$04,$00
paper_21c4:
			 BYTE	$02,$03,$07,$80  ;ascii ".@......"
             BYTE   $00,$40,$07,$80,$01,$05,$00,$0e  ;ascii ".@......"
             BYTE   $11,$16,$08
paper_21d3:
			 BYTE	$01,$05,$38,$44,$83  ;ascii ".....8D."
             BYTE   $cc,$30
paper_21da:
			 BYTE	$01,$16,$3f,$fc,$78,$98  ;ascii "L0..?|x."
             BYTE   $78,$f8,$38,$d8,$78,$b8,$78,$d8  ;ascii "xx8Xx8xX"
             BYTE   $78,$98,$78,$f8,$38,$d8,$78,$b8  ;ascii "x.xx8Xx8"
             BYTE   $7c,$df
paper_21f2:
			 BYTE	$7f,$ff,$ff,$ff,$80,$00  ;ascii "|_......"
             BYTE   $80,$00,$00,$00,$40,$00,$80,$00  ;ascii "....@..."
             BYTE   $00,$00,$40,$00,$83,$ff,$c0,$00  ;ascii "..@...@."
             BYTE   $60,$00,$83,$ff,$c0,$00,$7f,$fc  ;ascii "`...@..|"
             BYTE   $8c,$03,$3c,$00,$60,$02,$8c,$03  ;ascii "..<.`..."
             BYTE   $3c,$00,$60,$02,$83,$fc,$03,$c0  ;ascii "<.`..|.@"
             BYTE   $60,$03,$83,$fc,$03,$c0,$60,$03  ;ascii "`..|.@`."
             BYTE   $83,$ff,$ff,$f0,$60,$03,$83,$ff  ;ascii "...p`..."
             BYTE   $ff,$f0,$60,$03,$80,$00,$00,$00  ;ascii ".p`....."
             BYTE   $60,$03,$80,$00,$00,$00,$60,$03  ;ascii "`.....`."
             BYTE   $7f,$ff,$ff,$ff,$e0,$03,$1f,$ff  ;ascii "....`..."
             BYTE   $ff,$ff,$cf,$fb,$08,$00,$00,$00  ;ascii "..O{...."
             BYTE   $00,$03,$08,$00,$00,$00,$00,$03
             BYTE   $08,$00,$00,$00,$00,$03,$08,$00
             BYTE   $00,$00,$00,$03,$08,$00,$00,$00
             BYTE   $00,$03,$08,$00,$00,$00,$00,$03
             BYTE   $08,$00,$00,$00,$00,$03,$08,$00
             BYTE   $00,$00,$00,$03,$08,$00,$00,$00
             BYTE   $00,$03,$08,$00,$00,$00,$49,$13  ;ascii "......I."
             BYTE   $08,$00,$00,$00,$5a,$ab,$08,$00  ;ascii "....Z+.."
             BYTE   $00,$00,$8a,$ab,$08,$00,$00,$00  ;ascii "...+...."
             BYTE   $89,$13,$08,$00,$00,$00,$00,$03
             BYTE   $08,$00,$00,$00,$00,$03,$07,$ff
             BYTE   $ff,$ff,$ff,$ff,$01,$ff,$ff,$ff
             BYTE   $ff,$fe
paper_22b2:
			 BYTE	$02,$07,$06,$30,$07,$70  ;ascii ".~...0.p"
             BYTE   $03,$e0,$01,$c0,$03,$e0,$07,$70  ;ascii ".`.@.`.p"
             BYTE   $06,$30
paper_22c2:
			 BYTE	$02,$07,$00,$00,$00,$30  ;ascii ".0.....0"
             BYTE   $06,$70,$07,$e0,$03,$c0,$01,$80  ;ascii ".p.`.@.."
             BYTE   $00,$00
paper_22d2:
			 BYTE	$00,$00,$00,$00,$00,$00
             BYTE   $d7,$b1,$9e,$f3,$d9,$ed,$d6,$b1  ;ascii "W1.sYmV1"
             BYTE   $9e,$d3,$59,$ad,$f6,$b5,$8c,$d3  ;ascii ".SY-v5.S"
             BYTE   $d9,$ef,$d6,$bb,$8c,$d3,$19,$a1  ;ascii "YoV;.S.!"
             BYTE   $d7,$b1,$8c,$f3,$1d,$af,$00,$00  ;ascii "W1.s./.."
             BYTE   $00,$00,$00,$00,$00,$00,$00,$00
             BYTE   $00,$00,$0f,$e0,$00,$00,$00,$00  ;ascii "...`...."
             BYTE   $30,$18,$00,$00,$00,$00,$c0,$06  ;ascii "0.....@."
             BYTE   $00,$00,$00,$00,$80,$02,$00,$00
             BYTE   $00,$00,$bf,$fa,$00,$00,$00,$00  ;ascii "..?z...."
             BYTE   $a0,$0a,$00,$00,$00,$00,$a0,$0a  ;ascii " ..... ."
             BYTE   $00,$00,$00,$00,$a0,$0a,$00,$00  ;ascii ".... ..."
             BYTE   $00,$00,$a0,$0a,$00,$00,$00,$00  ;ascii ".. ....."
             BYTE   $a0,$0a,$00,$00,$00,$00,$a0,$0a  ;ascii " ..... ."
             BYTE   $00,$00,$00,$00,$a0,$0a,$00,$00  ;ascii ".... ..."
             BYTE   $00,$00,$bf,$fa,$00,$00,$00,$00  ;ascii "..?z...."
             BYTE   $80,$02,$00,$00,$00,$00,$80,$02
             BYTE   $00,$00,$00,$00,$9c,$a2,$00,$00  ;ascii ".....".."
             BYTE   $00,$00,$b6,$02,$00,$00,$00,$00  ;ascii "..6....."
             BYTE   $a2,$da,$00,$00,$00,$00,$b6,$da  ;ascii ""Z....6Z"
             BYTE   $00,$00,$00,$00,$9c,$02,$00,$00
             BYTE   $00,$00,$80,$02,$00,$00,$00,$00
             BYTE   $80,$02,$00,$00,$00,$00,$60,$0c  ;ascii "......`."
             BYTE   $00,$00,$00,$00,$1f,$f0,$00,$00  ;ascii ".....p.."
             BYTE   $00,$00
paper_2392:
			 BYTE	$04,$19,$d9,$92,$e0,$00  ;ascii "....Y.`."
             BYTE   $aa,$52,$87,$e0,$aa,$52,$c8,$58  ;ascii "*R.`*RHX"
             BYTE   $8a,$52,$87,$86,$8a,$52,$87,$ff  ;ascii ".R...R.."
             BYTE   $89,$9c,$e0,$00,$00,$00,$00,$00  ;ascii "..`....."
             BYTE   $00,$27,$57,$77,$6c,$64,$55,$52  ;ascii ".'WwldUR"
             BYTE   $aa,$a7,$75,$52,$ea,$e1,$55,$52  ;ascii "*'uRjaUR"
             BYTE   $00,$07,$57,$72,$00,$00,$10,$00  ;ascii "..Wr...."
             BYTE   $19,$00,$2c,$20,$22,$94,$42,$37  ;ascii ".., ".B7"
             BYTE   $3a,$88,$92,$25,$2a,$94,$64,$37  ;ascii ":..%*.d7"
             BYTE   $39,$00,$18,$00,$00,$00,$00,$00  ;ascii "9......."
             BYTE   $00,$03,$8c,$66,$d6,$62,$52,$88  ;ascii "...fVbR."
             BYTE   $95,$53,$92,$44,$d5,$52,$52,$22  ;ascii ".S.DURR""
             BYTE   $95,$62,$52,$22,$00,$03,$8c,$cc  ;ascii ".bR"...L"
paper_23f8:
             BYTE   $04,$19,$00,$00,$00,$70,$60,$48  ;ascii ".....p`H"
             BYTE   $00,$f8,$55,$6d,$d8,$d8,$65,$49  ;ascii ".xUmXXeI"
             BYTE   $54,$f8,$55,$49,$54,$d8,$77,$6d  ;ascii "TxUITXwm"
             BYTE   $d4,$d8,$00,$00,$00,$00,$07,$57  ;ascii "TX.....W"
             BYTE   $77,$00,$04,$55,$52,$00,$07,$75  ;ascii "w..UR..u"
             BYTE   $52,$00,$01,$55,$52,$00,$07,$57  ;ascii "R..UR..W"
             BYTE   $72,$00,$00,$00,$00,$00,$00,$00  ;ascii "r......."
             BYTE   $00,$f0,$60,$48,$00,$d8,$55,$6d  ;ascii ".p`H.XUm"
             BYTE   $d8,$f8,$65,$49,$54,$d8,$55,$49  ;ascii "XxeITXUI"
             BYTE   $54,$f8,$77,$6d,$d4,$f8,$00,$00  ;ascii "TxwmTx.."
             BYTE   $00,$00,$03,$3b,$6c,$00,$02,$aa  ;ascii "...;l..*"
             BYTE   $aa,$00,$03,$aa,$2e,$00,$02,$aa  ;ascii "*..*...*"
             BYTE   $2a,$00,$03,$ba,$2e,$00          ;ascii "*..:.."
