; ! VMU disassembler output has been modified to have data position labels

; LC86104C/108C disassembler. (C) 1999-2000 John Maushammer.
;  Version 1.04                             john@maushammer.com
;  GNU public liscense - see www.gnu.org
;
;
; Source file=SLIDEPUZ.VMS, 3584 (0x0e00) bytes.
; Assembler output mode output enabled.
; Mapping memory...   reset/start entry point
; Mapping memory...   interrupt entry points
; Searching for text strings... (4 strings found)
; Done mapping memory.

slidepuzzle:       MOV    #$a1,OCR          ;set 32 kHz clock speed (normal)
             MOV    #$09,MCR
             MOV    #$80,VCCR         ;turn on LCD
             CLR1   P3INT, 0          ;disable port 3 interrupts
             CLR1   P1, 7
             MOV    #$01,$045
             MOV    #$ff,P3           ;allow us to read buttons
             CLR1   PSW, 1            ;access OS ram bank
             LD     $01d
             SET1   PSW, 1            ;access game ram bank
             ST     $0fe
             CALLF  L098E
             MOV    #$80,$000
             MOV    #$00,ACC
L0524:       ST     @R0
             INC    ACC
             INC    $000
             BNE    #$18,L0524
             MOV    #$17,$09f
             CALLF  L06DF
             CALLF  L05A4
L0535:       CALLF  L063A
             BNZ    L0544
             CALLF  L06DF
             CALLF  L065E
             BZ     L0535
             BR     L0563

L0544:       MOV    #$ff,$09f
             CALLF  L06DF
             MOV    #$e5,T1L
             MOV    #$fe,T1LC
             MOV    #$d4,T1CNT
             SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             MOV    #$00,T1CNT        ;Stop Timer1 (sound off)
             MOV    #$3f,$0ff
L055B:       MOV    #$ff,ACC
             CALLF  L08F3
             BZ     L055B
L0563:       JMPF   quit

L0566:       PUSH   B
             PUSH   C
             PUSH   TRL
             ST     TRL
             LD     $0fe
             ST     C
             MOV    #$00,ACC
             MOV    #$53,B
             MUL                         ; B:ACC:C <- ACC:C * B
             XCH    B
             LD     C
             ADD    #$ef
             ST     C
             LD     B
             ADDC   #$1e
             MOV    #$f1,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             LD     B
             ST     $0fe
             ST     C
             LD     TRL
             ST     B
             MOV    #$00,ACC
             MUL                         ; B:ACC:C <- ACC:C * B
             MOV    #$f1,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             LD     C
             POP    TRL
             POP    C
             POP    B
             RET    

L05A4:       PUSH   ACC
             PUSH   B
             PUSH   C
             PUSH   TRL
             PUSH   TRH
             PUSH   $000
             PUSH   $001
             MOV    #>shuffling,TRH
             MOV    #<shuffling,TRL
             MOV    #$00,B
             MOV    #$00,C
             CALLF  L07C5
             MOV    #$00,TRL
L05C4:       LD     $09e
             ST     C
             MOV    #$00,ACC
             MOV    #$06,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             MOV    #$a0,$000
             LD     C
             BZ     L05E1
             PUSH   ACC
             LD     $09e
             SUB    #$06
             ST     @R0
             INC    $000
             POP    ACC
L05E1:       BE     #$03,L05EB
             LD     $09e
             ADD    #$06
             ST     @R0
             INC    $000
L05EB:       LD     B
             BZ     L05FA
             PUSH   ACC
             LD     $09e
             SUB    #$01
             ST     @R0
             INC    $000
             POP    ACC
L05FA:       BE     #$05,L0604
             LD     $09e
             ADD    #$01
             ST     @R0
             INC    $000
L0604:       LD     $000
             SUB    #$a0
             CALLF  L0566
             ADD    #$a0
             ST     $000
             LD     @R0
             ADD    #$80
             ST     $000
             LD     $09e
             ADD    #$80
             ST     $001
             LD     @R0
             PUSH   ACC
             LD     @R1
             ST     @R0
             POP    ACC
             ST     @R1
             LD     $000
             SUB    #$80
             ST     $09e
             DBNZ   TRL,L05C4
             POP    $001
             POP    $000
             POP    TRH
             POP    TRL
             POP    C
             POP    B
             POP    ACC
             RET    

L063A:       PUSH   $000
             PUSH   B
             MOV    #$80,$000
             MOV    #$00,B
L0644:       LD     @R0
             BNE    B,L0656
             INC    B
             INC    $000
             LD     B
             BNE    #$18,L0644
             MOV    #$01,ACC
             BR     L0659

L0656:       MOV    #$00,ACC
L0659:       POP    B
             POP    $000
             RET    

L065E:       PUSH   B
             PUSH   C
             LD     $09e
             ST     C
             MOV    #$00,ACC
             MOV    #$06,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             MOV    #$20,$0ff
             LD     C
             BNZ    L0676
             SET1   $0ff, 1
L0676:       BNE    #$03,L067B
             SET1   $0ff, 0
L067B:       LD     B
             BNZ    L0681
             SET1   $0ff, 3
L0681:       BNE    #$05,L0686
             SET1   $0ff, 2
L0686:       MOV    #$ff,ACC
             CALLF  L08F3
             BZ     L0686
             BE     #$01,L06DA
             BN     ACC, 0, L06A7
             BN     ACC, 1, L06AD
             BN     ACC, 2, L06B3
             BN     ACC, 3, L06B9
             BN     ACC, 4, L06A2
             BR     L0686

L06A2:       CALLF  L0796
             BR     L06DA

L06A7:       LD     $09e
             ADD    #$06
             BR     L06BD

L06AD:       LD     $09e
             SUB    #$06
             BR     L06BD

L06B3:       LD     $09e
             ADD    #$01
             BR     L06BD

L06B9:       LD     $09e
             SUB    #$01
L06BD:       PUSH   $000
             PUSH   $001
             ADD    #$80
             ST     $000
             LD     $09e
             ADD    #$80
             ST     $001
             LD     @R0
             PUSH   ACC
             LD     @R1
             ST     @R0
             POP    ACC
             ST     @R1
             POP    $001
             POP    $000
             MOV    #$00,ACC
L06DA:       POP    C
             POP    B
             RET    

L06DF:       PUSH   ACC
             PUSH   B
             PUSH   C
             PUSH   TRL
             PUSH   TRH
             PUSH   VSEL
             PUSH   VRMAD1
             PUSH   VRMAD2
             PUSH   $000
             PUSH   $001
             PUSH   $003
             MOV    #$10,VSEL
             MOV    #$00,VRMAD1
             MOV    #$00,VRMAD2
             MOV    #$a0,$000
             MOV    #$80,$001
L0704:       LD     @R1
             ST     C
             BNE    $09f,L0710
             LD     $001
             SUB    #$80
             ST     $09e
L0710:       MOV    #$00,ACC
             MOV    #$06,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             PUSH   B
             MOV    #$00,ACC
             MOV    #$30,B
             MUL                         ; B:ACC:C <- ACC:C * B
             LD     C
             POP    B
             ADD    B
             ST     @R0
             INC    $000
             INC    $001
             LD     $001
             BNE    #$98,L0704
             MOV    #>data_0c1a,TRH
             MOV    #<data_0c1a,TRL
             MOV    #$04,B
             MOV    #$a0,$003
             MOV    #$80,$001
L073F:       MOV    #$08,C
             LD     $003
             ST     $000
             ADD    #$06
             ST     $003
             LD     $001
             ADD    #$06
             ST     $001
L0750:       LD     $003
             SUB    #$06
             ST     $000
             LD     $001
             SUB    #$06
             ST     $001
L075C:       LD     @R1
             BNE    $09f,L0765
             MOV    #$00,ACC
             BR     L0767

L0765:       LD     @R0
             LDC    
L0767:       ST     VTRBF       ;write to work RAM
             LD     @R0
             ADD    #$06
             ST     @R0
             INC    $000
             INC    $001
             LD     $000
             BNE    $003,L075C
             DBNZ   C,L0750
             DBNZ   B,L073F
             CALLF  L0914
             POP    $003
             POP    $001
             POP    $000
             POP    VRMAD2
             POP    VRMAD1
             POP    VSEL
             POP    TRH
             POP    TRL
             POP    C
             POP    B
             POP    ACC
             RET    

L0796:       PUSH   $0ff
             PUSH   TRL
             PUSH   TRH
             MOV    #$2f,$0ff
             MOV    #>data_0b5a,TRH
             MOV    #<data_0b5a,TRL
             CALLF  L095E
L07A8:       BN     P3, 4, L07A8      ;branch if A button pressed
L07AB:       MOV    #$01,ACC
             CALLF  L08F3
             BE     #$01,L07BE
             BZ     L07AB
             BN     ACC, 4, L07BB
             BR     L07AB

L07BB:       MOV    #$00,ACC
L07BE:       POP    TRH
             POP    TRL
             POP    $0ff
             RET    

L07C5:       PUSH   ACC
             PUSH   $003
             PUSH   OCR
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             MOV    #$00,$003
L07D0:       LD     $003
             LDC    
             BZ     L07DE
             CALLF  L07E5
             INC    B
             INC    $003
             BR     L07D0

L07DE:       POP    OCR
             POP    $003
             POP    ACC
             RET    

L07E5:       PUSH   ACC
             PUSH   B
             PUSH   C
             PUSH   TRL
             PUSH   TRH
             PUSH   XBNK
             PUSH   OCR
             PUSH   $002
             PUSH   $001
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             MOV    #>data_09c2,TRH
             MOV    #<data_09c2,TRL
             SUB    #$20
             PUSH   B
             PUSH   C
             ST     B
             MOV    #$06,C
             MOV    #$00,ACC
             MUL                         ; B:ACC:C <- ACC:C * B
             XCH    B
             LD     TRL
             ADD    C
             ST     TRL
             LD     TRH
             ADDC   B
             ST     TRH
             POP    C
             POP    B
             MOV    #$00,XBNK
             LD     C
             AND    #$10
             BZ     L082C
             MOV    #$01,XBNK
L082C:       LD     C
             AND    #$0e
             CLR1   PSW, 7             ;clear carry flag
             ROLC   
             CLR1   PSW, 7             ;clear carry flag
             ROLC   
             CLR1   PSW, 7             ;clear carry flag
             ROLC   
             ADD    #$80
             ST     $002
             LD     C
             AND    #$01
             BZ     L0849
             LD     $002
             ADD    #$06
             ST     $002
L0849:       LD     B
             AND    #$0e
             CLR1   PSW, 7             ;clear carry flag
             RORC   
             ADD    $002
             ST     $002
             LD     B
             MOV    #$f0,B
             AND    #$01
             BZ     L0860
             MOV    #$0f,B
L0860:       MOV    #$00,C
             LD     B
             XOR    #$ff
             ST     $001
L0869:       LD     C
             PUSH   C
             LDC    
             AND    B
             ST     C
             LD     @R2
             AND    $001
             OR     C
             ST     @R2
             LD     $002
             AND    #$0f
             BE     #$06,L088A
             BN     PSW, 7, L088A      ;branch if carry clear
             LD     $002
             ADD    #$06
             ST     $002
             BR     L089D

L088A:       LD     $002
             ADD    #$0a
             ST     $002
             BN     PSW, 7, L089D      ;branch if carry clear
             ADD    #$80
             ST     $002
             LD     XBNK
             XOR    #$01
             ST     XBNK
L089D:       POP    C
             INC    C
             LD     C
             BNE    #$06,L0869
             POP    $001
             POP    $002
             POP    OCR
             POP    XBNK
             POP    TRH
             POP    TRL
             POP    C
             POP    B
             POP    ACC
             RET    

L08B9:       BN     P3, 7, L08B9      ;branch if Sleep button pressed
             MOV    #$00,VCCR         ;turn off LCD
L08BF:       SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             BP     P7, 0, L08CF      ;branch if Dreamcast connected
             BP     P3, 7, L08BF      ;branch if Sleep button isn't pressed
L08C7:       BN     P3, 7, L08C7      ;branch if Sleep button pressed
             MOV    #$00,ACC
             BR     L08D2

L08CF:       MOV    #$01,ACC
L08D2:       MOV    #$80,VCCR         ;turn on LCD
             RET    

L08D6:       BP     P7, 0, L08EB      ;branch if Dreamcast connected
             LD     P3                ;read buttons
             OR     $0ff
             BE     #$ff,L08EF
             BN     ACC, 6, L08EB
             BP     ACC, 7, L08F2
             CALLF  L08B9
             BR     L08EF

L08EB:       MOV    #$01,ACC
             RET    

L08EF:       MOV    #$00,ACC
L08F2:       RET    

L08F3:       PUSH   B
             PUSH   C
             ST     B
L08F9:       MOV    #$20,C
L08FC:       CALLF  L08D6
             BNZ    L090F
             DBNZ   C,L08FC
             LD     B
             BE     #$ff,L08F9
             DBNZ   B,L08F9
             MOV    #$00,ACC
L090F:       POP    C
             POP    B
             RET    

L0914:       PUSH   ACC
             PUSH   VSEL
             PUSH   VRMAD1
             PUSH   VRMAD2
             PUSH   XBNK
             PUSH   $002
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             MOV    #$10,VSEL
             MOV    #$00,VRMAD1
             MOV    #$00,VRMAD2
             MOV    #$00,XBNK
L092E:       MOV    #$80,$002
L0931:       LD     VTRBF       ;read from work RAM
             ST     @R2
             INC    $002
             LD     $002
             AND    #$0f
             BNE    #$0c,L0943
             LD     $002
             ADD    #$04
             ST     $002
L0943:       LD     $002
             BNZ    L0931
             BP     XBNK, 0, L094F
             MOV    #$01,XBNK
             BR     L092E

L094F:       SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             POP    $002
             POP    XBNK
             POP    VRMAD2
             POP    VRMAD1
             POP    VSEL
             POP    ACC
             RET    

L095E:       PUSH   ACC
             PUSH   B
             PUSH   VSEL
             PUSH   VRMAD1
             PUSH   VRMAD2
             MOV    #$10,VSEL
             MOV    #$00,VRMAD1
             MOV    #$00,VRMAD2
             MOV    #$00,B
             LD     B
L0976:       LDC    
             ST     VTRBF       ;write to work RAM
             INC    B
             LD     B
             BNE    #$c0,L0976
             POP    VRMAD2
             POP    VRMAD1
             POP    VSEL
             POP    B
             POP    ACC
             CALLF  L0914
             RET    

L098E:       CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             PUSH   ACC
             PUSH   XBNK
             PUSH   $002
             MOV    #$00,XBNK
L0999:       MOV    #$80,$002
L099C:       MOV    #$00, @R2
             INC    $002
             LD     $002
             AND    #$0f
             BNE    #$0c,L09AD
             LD     $002
             ADD    #$04
             ST     $002
L09AD:       LD     $002
             BNZ    L099C
             BP     XBNK, 0, L09B9
             MOV    #$01,XBNK
             BR     L0999

L09B9:       POP    $002
             POP    XBNK
             POP    ACC
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             RET    

