; LC86104C/108C disassembler. (C) 1999-2000 John Maushammer.
;  Version 1.04                             john@maushammer.com
;  GNU public liscense - see www.gnu.org
;
;
; Source file=VISION.VMS, 7680 (0x1e00) bytes.
; Assembler output mode output enabled.
; Mapping memory...   reset/start entry point
; Mapping memory...   interrupt entry points
; Searching for text strings... (1 strings found)
; Done mapping memory.






; changed: this clock interrupt handler is called from allstars.s
L0139:       PUSH   ACC
             PUSH   PSW
             SET1   PSW, 1            ;access game ram bank
             INC    $010
             BN     $010, 0, L0159
             BP     $017, 7, L0159
             LD     $016
             OR     $017
             BZ     L0159
             LD     $016
             SUB    #$01
             ST     $016
             LD     $017
             SUBC   #$00
             ST     $017
L0159:       POP    PSW
             POP    ACC
             CLR1   BTCR, 1
             POP    IE
             RETI   


vision:       MOV    #$a1,OCR          ;set 32 kHz clock speed (normal)
             MOV    #$09,MCR
             MOV    #$80,VCCR         ;turn on LCD
             CLR1   P3INT, 0          ;disable port 3 interrupts
             CLR1   P1, 7
             MOV    #$ff,P3           ;allow us to read buttons
             CLR1   PSW, 3
             CLR1   PSW, 4
             CLR1   PSW, 1            ;access OS ram bank
             MOV    #$ff,$06e
             SET1   PSW, 1            ;access game ram bank
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             MOV    #$00,T1CNT        ;Stop Timer1 (sound off)
             MOV    #$ff,T1L
             MOV    #$ff,T1LC
             MOV    #$ff,$013
             CLR1   PSW, 1            ;access OS ram bank
             LD     $06d
             SET1   PSW, 1            ;access game ram bank
             BNZ    L08C0
             MOV    #<vision_17a3,TRL
             MOV    #>vision_17a3,TRH
             CALLF  L1176
             MOV    #$0a,C
             CALLF  L0C1D
L08C0:       MOV    #$20,C
             CALLF  L112A
L08C6:       MOV    #$00,$01a
             MOV    #$00,$012
L08CC:       MOV    #<vision_1863,TRL
             MOV    #>vision_1863,TRH
             CALLF  L11A3
             CALLF  L0C51
             BN     ACC, 4, L08CC
L08DB:       CALLF  L0C51
             BN     ACC, 4, L08F7
             MOV    #<vision_1863,TRL
             MOV    #>vision_1863,TRH
             CALLF  L11A3
             LD     $012
             BNE    #$14,L08DB
             CALLF  L0C71
             MOV    #$00,$012
             BR     L08DB

L08F7:       MOV    #$00,$014
             MOV    #$00,$015
L08FD:       MOV    #$20,C
             CALLF  L112A
             CALLF  L13A3
             CALLF  L0C8F
             CALLF  L0CF0
             MOV    #$d7,$01c
             MOV    #$d7,$001
             LD     @R1
             CALLF  L1037
             MOV    #$00,$01d
L0919:       CALLF  L0B1C
             CALLF  L12F5
             LD     $016
             OR     $017
             BNZ    L0928
             BRF    L0AC5

L0928:       CALLF  L0C51
             BN     ACC, 0, L093C
             BN     ACC, 1, L094B
             BN     ACC, 2, L095A
             BN     ACC, 3, L0969
             BN     ACC, 4, L0978
             BR     L0919

L093C:       LD     $01c
             SUB    #$09
             ST     $001
             LD     @R1
             BN     ACC, 6, L0919
             CALLF  L0B8E
             BR     L0919

L094B:       LD     $01c
             ADD    #$09
             ST     $001
             LD     @R1
             BN     ACC, 6, L0919
             CALLF  L0B8E
             BR     L0919

L095A:       LD     $01c
             DEC    ACC
             ST     $001
             LD     @R1
             BN     ACC, 6, L0919
             CALLF  L0B8E
             BR     L0919

L0969:       LD     $01c
             INC    ACC
             ST     $001
             LD     @R1
             BN     ACC, 6, L0919
             CALLF  L0B8E
             BR     L0919

L0978:       LD     $01d
             BNZ    vision_L099C
             LD     $01c
             ST     $001
             LD     @R1
             BN     ACC, 7, L0919
L0984:       LD     $01c
             ST     $01d
             MOV    #$22,ACC
             CALLF  L1636
vision_L098E:       CALLF  L0C51
             BP     ACC, 4, L0919
             CALLF  L0B1C
             CALLF  L12F5
             BR     vision_L098E

vision_L099C:       LD     $01e
             BNZ    L09C7
L09A0:       LD     $01d
             ST     $001
             LD     @R1
             CALLF  L0FA4
             XOR    ACC
             XCH    $01d
             BNE    $01c,L09B7
             MOV    #$25,ACC
             CALLF  L1636
             BR     vision_L098E

L09B7:       LD     $01c
             ST     $001
             LD     @R1
             BP     ACC, 7, L0984
             MOV    #$25,ACC
             CALLF  L1636
             BR     vision_L098E

L09C7:       ST     $001
             LD     @R1
             BN     ACC, 7, L09A0
             CLR1   ACC, 7
             ST     @R1
             CALLF  L0FD3
             LD     $01d
             ST     $001
             LD     @R1
             CLR1   ACC, 7
             ST     @R1
             CALLF  L0FD3
             LD     $01c
             ST     $001
             LD     @R1
             SET1   ACC, 7
             ST     @R1
             CALLF  L0FA4
             MOV    #$28,ACC
             CALLF  L1636
             MOV    #$00,$01d
             CALLF  L0BBD
             LD     $020
             BE     #$01,L0A04
             LD     $021
             BZ     L0A7A
             CALLF  L0C4A
             BRF    L0919

L0A04:       MOV    #$2d,ACC
             CALLF  L1636
             MOV    #$07,B
             CALLF  L0C34
             CALLF  L115F
             INC    $014
             LD     $014
             BE     #$20,L0A43
             MOV    #$06,ACC
             MOV    #<vision_1a5e,TRL
             MOV    #>vision_1a5e,TRH
             CALLF  L144B
             CALLF  L1489
             MOV    #$04,B
             CALLF  L0C34
             INC    $015
             CALLF  L1489
             MOV    #$54,ACC
             CALLF  L1636
             MOV    #$06,B
             CALLF  L0C34
             BRF    L08FD

L0A43:       MOV    #$00,$022
L0A46:       MOV    #<vision_1b8a,TRL
             MOV    #>vision_1b8a,TRH
             CALLF  L14D9
             LD     $022
             BNE    #$4d,L0A46
             MOV    #$12,B
             CALLF  L150E
             MOV    #$00,$022
L0A5D:       MOV    #<vision_1d58,TRL
             MOV    #>vision_1d58,TRH
             CALLF  L14D9
             LD     $022
             BNE    #$0f,L0A5D
             MOV    #$0c,B
             CALLF  L150E
             MOV    #$0c,B
             CALLF  L0C34
             BRF    L08C6

L0A7A:       MOV    #$40,ACC
             CALLF  L1636
             MOV    #$07,B
             CALLF  L0C34
             LD     $015
             BNZ    L0AA2
L0A8A:       CALLF  L115F
             MOV    #$0a,ACC
             MOV    #<vision_1b4e,TRL
             MOV    #>vision_1b4e,TRH
             CALLF  L144B
             MOV    #$08,C
             CALLF  L0C1D
             BRF    L08C6

L0AA2:       CALLF  L115F
             MOV    #$06,ACC
             MOV    #<vision_1ad6,TRL
             MOV    #>vision_1ad6,TRH
             CALLF  L144B
             MOV    #$10,ACC
             MOV    #<vision_1b12,TRL
             MOV    #>vision_1b12,TRH
             CALLF  L144B
             MOV    #$08,C
             CALLF  L0C1D
             BR     L0AED

L0AC5:       CALLF  L12F5
             MOV    #$47,ACC
             CALLF  L1636
             MOV    #$07,B
             CALLF  L0C34
             LD     $015
             BZ     L0A8A
             CALLF  L115F
             MOV    #$0a,ACC
             MOV    #<vision_1a9a,TRL
             MOV    #>vision_1a9a,TRH
             CALLF  L144B
             MOV    #$08,C
             CALLF  L0C1D
L0AED:       MOV    #$20,C
             CALLF  L112A
             MOV    #$06,ACC
             MOV    #<vision_1a5e,TRL
             MOV    #>vision_1a5e,TRH
             CALLF  L144B
             CALLF  L1489
             MOV    #$04,B
             CALLF  L0C34
             DEC    $015
             CALLF  L1489
             MOV    #$59,ACC
             CALLF  L1636
             MOV    #$06,B
             CALLF  L0C34
             BRF    L08FD

L0B1C:       MOV    #$00,$01e
             INC    $011
             LD     $01d
             BNZ    L0B26
L0B25:       RET    

L0B26:       ST     $001
             LD     @R1
             BN     $011, 3, L0B31
             CALLF  L0FD3
             BR     L0B34

L0B31:       CALLF  L0FA4
L0B34:       LD     $01d
             BE     $01c,L0B25
             ST     B
             LD     $01c
             ST     $001
             LD     @R1
             BP     ACC, 7, L0B25
             LD     $01c
             BE     B,L0B4D
             BN     PSW, 7, L0B4D      ;branch if carry clear
             XCH    B
L0B4D:       ST     C
             SUB    B
             BP     ACC, 0, L0B25
             ROR    
             BE     #$01,L0B61
             BE     #$08,L0B61
             BE     #$09,L0B61
             BNE    #$0a,L0B25
L0B61:       ADD    B
             ST     B
             ST     $001
             LD     @R1
             BN     ACC, 7, L0B25
             XCH    B
             ST     $01e
             LD     B
             BN     $011, 3, L0B81
             CALLF  L0FD3
             LD     $01c
             ST     $01f
             ST     $001
             LD     @R1
             JMPF   L107C

L0B81:       CALLF  L0FA4
             LD     $01c
             ST     $01f
             ST     $001
             LD     @R1
             JMPF   L1071

L0B8E:       PUSH   $001
             LD     $01c
             ST     $001
             LD     @R1
             CALLF  L0FFD
             POP    ACC
             ST     $01c
             ST     $001
             LD     @R1
             CALLF  L1037
             LD     $01e
             BZ     L0BB4
             ST     $001
             LD     @R1
             CALLF  L0FA4
             LD     $01f
             ST     $001
             LD     @R1
             CALLF  L107C
L0BB4:       CALLF  L0C51
             AND    #$0f
             BNE    #$0f,L0BB4
             RET    

L0BBD:       MOV    #$00,$020
             MOV    #$00,$021
             MOV    #<vision_0c15,TRL
             MOV    #>vision_0c15,TRH
             MOV    #$bb,$001
L0BCC:       LD     @R1
             BN     ACC, 7, L0BD5
             INC    $020
             CALLF  L0BDD
L0BD5:       INC    $001
             LD     $001
             BNE    #$f4,L0BCC
             RET    

L0BDD:       PUSH   $001
             LD     $001
             SUB    #$0a
             ST     $001
             SUB    #$0a
             ST     $000
             MOV    #$00,C
L0BEC:       LD     @R1
             BN     ACC, 7, L0BFB
             LD     @R0
             AND    #$c0
             BNE    #$40,L0BFB
             INC    $021
             POP    $001
             RET    

L0BFB:       LD     C
             LDC    
             BNZ    L0C03
             POP    $001
             RET    

L0C03:       ST     B
             ADD    $001
             ST     $001
             LD     B
             ROL    
             ADD    $000
             ST     $000
             INC    C
             BRF    L0BEC

vision_0c15:
             BYTE   $01,$01,$07
             BYTE   $02,$07,$01,$01,$00
L0C1D:       MOV    #$00,$010
L0C20:       CALLF  L0C51
             BN     ACC, 4, L0C31
             LD     $010
             BE     C,L0C2E
             BP     PSW, 7, L0C20      ;branch if carry set
L0C2E:       CLR1   PSW, 7             ;clear carry flag
             RET    

L0C31:       SET1   PSW, 7             ;set carry flag
             RET    

L0C34:       MOV    #$00,$010
L0C37:       CALLF  L0C51
             LD     $010
             BE     B,L0C42
             BP     PSW, 7, L0C37      ;branch if carry set
L0C42:       RET    

             BYTE   $20,$0c,$51,$7c,$00              ;ascii " .Q|."
             BYTE   $fa,$a0                          ;ascii "z "
L0C4A:       CALLF  L0C51
             BN     ACC, 4, L0C4A
             RET    

L0C51:       BP     P7, 0, L0C67      ;branch if Dreamcast connected
             LD     P3                ;read buttons
             BN     ACC, 6, L0C67
             BN     ACC, 7, L0C71
             BP     ACC, 5, L0C66
             SET1   $017, 7
             CALLF  L157E
             CLR1   $017, 7
L0C66:       RET    

L0C67:       CLR1   PSW, 1            ;access OS ram bank
             MOV    #$00,$06e
             SET1   PSW, 1            ;access game ram bank
             JMPF   quit

L0C71:       SET1   $017, 7
             SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             BN     P3, 7, L0C71      ;branch if Sleep button pressed
             MOV    #$00,VCCR         ;turn off LCD
L0C7B:       SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             BP     P7, 0, L0C67      ;branch if Dreamcast connected
             BP     P3, 7, L0C7B      ;branch if Sleep button isn't pressed
             MOV    #$80,VCCR         ;turn on LCD
L0C86:       SET1   PCON, 0           ;hold- CPU & timers sleep until interrupt
             BN     P3, 7, L0C86      ;branch if Sleep button pressed
             CLR1   $017, 7
             BR     L0C51

L0C8F:       MOV    #$af,$001
             MOV    #$40,C
             MOV    #$09,B
             CALLF  L0CDD
             CALLF  L0CB7
             CALLF  L0CB7
             CALLF  L0CCA
             CALLF  L0CCA
             CALLF  L0CCA
             CALLF  L0CB7
             CALLF  L0CB7
             MOV    #$09,B
             CALLF  L0CDD
             RET    

L0CB7:       MOV    #$03,B
             CALLF  L0CDD
             MOV    #$03,B
             CALLF  L0CE5
             MOV    #$03,B
             CALLF  L0CDD
             RET    

L0CCA:       MOV    #$01,B
             CALLF  L0CDD
             MOV    #$07,B
             CALLF  L0CE5
             MOV    #$01,B
             CALLF  L0CDD
             RET    

L0CDD:       MOV    #$00, @R1
             INC    $001
             DBNZ   B,L0CDD
             RET    

L0CE5:       LD     C
             ST     @R1
             INC    C
             INC    $001
             DBNZ   B,L0CE5
             RET    

L0CF0:       MOV    #<vision_194a,TRL
             MOV    #>vision_194a,TRH
             MOV    #$00,XBNK
             CALLF  L12CB
             MOV    #<vision_1954,TRL
             MOV    #>vision_1954,TRH
             MOV    #$01,XBNK
             CALLF  L12CB
             LD     $014
             ROL    
             AND    #$fe
             ADD    #<vision_0d9b		; changed: 	$9b
             ST     TRL
             MOV    #>vision_0d9b,ACC	; changed:	$0d,ACC
             ADDC   #$00
             ST     TRH
             MOV    #$00,ACC
             LDC    
             ST     B
             MOV    #$01,ACC
             LDC    
             ST     TRH
             LD     B
             ST     TRL
             MOV    #$af,$001
             MOV    #$00,B
             LD     B
             LDC    
             ST     $016
             INC    B
             LD     B
             LDC    
             SET1   ACC, 7
             ST     $017
             INC    B
             PUSH   B
             PUSH   TRL
             PUSH   TRH
             CALLF  L12F5
             CALLF  L133B
             MOV    #$01,B
             CALLF  L0C34
             MOV    #$00,ACC
             CALLF  L1636
             MOV    #$01,B
             CALLF  L0C34
             POP    TRH
             POP    TRL
             POP    B
L0D62:       LD     B
             LDC    
             BE     #$ff,L0D98
             PUSH   B
             PUSH   ACC
             PUSH   TRL
             PUSH   TRH
             CALLF  L0FA4
             MOV    #$1f,ACC
             CALLF  L1636
             MOV    #$01,B
             CALLF  L0C34
             POP    TRH
             POP    TRL
             POP    C
             POP    B
             INC    B
             SET1   C, 6
L0D8B:       LD     @R1
             BE     C,L0D93
             INC    $001
             BR     L0D8B

L0D93:       SET1   ACC, 7
             ST     @R1
             BR     L0D62

L0D98:       CLR1   $017, 7
             RET    

; data shifted elsewhere
; workaround
	.org $d9b
vision_0d9b:
             BYTE   $db,$0d,$e1,$0d,$e9              ;ascii "[.a.i"
             BYTE   $0d,$f2,$0d,$fa,$0d,$03,$0e,$0d  ;ascii ".r.z...."
             BYTE   $0e,$19,$0e,$23,$0e,$2e,$0e,$35  ;ascii "...#...5"
             BYTE   $0e,$41,$0e,$4c,$0e,$57,$0e,$62  ;ascii ".A.L.W.b"
             BYTE   $0e,$73,$0e,$80,$0e,$8d,$0e,$9c  ;ascii ".s......"
             BYTE   $0e,$ab,$0e,$ba,$0e,$c9,$0e,$da  ;ascii ".+.:.I.Z"
             BYTE   $0e,$e6,$0e,$fa,$0e,$0a,$0f,$1c  ;ascii ".f.z...."
             BYTE   $0f,$32,$0f,$46,$0f,$5e,$0f,$76  ;ascii ".2.F.^.v"
             BYTE   $0f,$81,$0f
vision_0ddb:
			 BYTE	$1e,$00,$08,$09,$10
             BYTE   $ff
vision_0de1:
			 BYTE	$23,$00,$09,$0a,$11,$16,$17  ;ascii ".#......"
             BYTE   $ff
vision_0de9:
			 BYTE	$28,$00,$04,$08,$09,$0f,$10  ;ascii ".(......"
             BYTE   $11,$ff
vision_0df2:
			 BYTE	$2d,$00,$08,$0e,$10,$11  ;ascii "..-....."
             BYTE   $20,$ff
vision_0dfa:
			 BYTE	$3c,$00,$03,$04,$08,$09  ;ascii " .<....."
             BYTE   $0f,$10,$ff
vision_0e3:
			 BYTE	$00,$08,$09,$0d  ;ascii "...K...."
             BYTE   $0e,$11,$16,$1c,$ff
vision_0e0d:
			 BYTE	$00,$08  ;ascii ".....Z.."
             BYTE   $09,$0b,$0e,$10,$12,$15,$1b,$1c
             BYTE   $ff,$63,$00,$00,$02,$03,$04,$0a  ;ascii ".c......"
             BYTE   $11,$17,$ff,$78,$00,$03,$04,$08  ;ascii "...x...."
             BYTE   $0a,$0e,$10,$16,$18,$ff,$0f,$00
             BYTE   $09,$0f,$10,$11,$ff,$8c,$00,$09
             BYTE   $0e,$0f,$11,$13,$17,$18,$1c,$20  ;ascii "....... "
             BYTE   $ff,$9b,$00,$06,$0f,$11,$18,$1b
             BYTE   $1c,$1d,$1f,$ff,$8c,$00,$09,$0a
             BYTE   $0f,$12,$16,$19,$1c,$1d,$ff,$a0  ;ascii "....... "
             BYTE   $00,$00,$01,$02,$05,$09,$0b,$0f
             BYTE   $12,$ff,$b4,$00,$01,$04,$08,$09  ;ascii "..4....."
             BYTE   $0d,$0e,$0f,$11,$12,$13,$17,$18
             BYTE   $1c,$1f,$ff,$be,$00,$04,$08,$0a  ;ascii "...>...."
             BYTE   $0d,$0e,$11,$12,$16,$18,$1c,$ff
             BYTE   $dc,$00,$03,$04,$06,$09,$0a,$0e  ;ascii "\......."
             BYTE   $10,$11,$12,$1c,$ff,$f0,$00,$00  ;ascii ".....p.."
             BYTE   $04,$09,$0a,$0e,$0f,$10,$11,$12
             BYTE   $16,$1c,$20,$ff,$2b,$01,$04,$08  ;ascii ".. .+..."
             BYTE   $09,$0a,$0e,$0f,$10,$11,$12,$16
             BYTE   $17,$1c,$ff,$49,$01,$06,$07,$08  ;ascii "...I...."
             BYTE   $09,$0a,$0e,$11,$16,$18,$1c,$1d
             BYTE   $20,$ff,$2f,$01,$03,$05,$08,$0b  ;ascii " ./....."
             BYTE   $0d,$0e,$10,$11,$12,$15,$16,$18
             BYTE   $ff,$a7,$01,$04,$06,$07,$08,$10  ;ascii ".'......"
             BYTE   $12,$14,$15,$16,$18,$19,$1a,$1b
             BYTE   $1c,$ff,$d3,$01,$08,$09,$0a,$0f  ;ascii "..S....."
             BYTE   $10,$11,$16,$17,$18,$ff,$24,$02  ;ascii "......$."
             BYTE   $02,$04,$06,$08,$09,$0a,$0f,$10
             BYTE   $11,$12,$13,$15,$17,$18,$19,$1b
             BYTE   $1c,$ff,$d7,$01,$01,$04,$09,$0d  ;ascii "..W....."
             BYTE   $0e,$0f,$10,$11,$12,$13,$17,$1c
             BYTE   $1f,$ff,$72,$02,$05,$07,$08,$09  ;ascii "..r....."
             BYTE   $0a,$0e,$0f,$10,$11,$12,$14,$16
             BYTE   $18,$1a,$1c,$ff,$a3,$02,$00,$01  ;ascii "....#..."
             BYTE   $02,$04,$07,$08,$0b,$0d,$0e,$0f
             BYTE   $10,$11,$12,$14,$16,$17,$18,$1b
             BYTE   $1f,$ff,$98,$01,$06,$07,$09,$0b
             BYTE   $0c,$0d,$0e,$0f,$10,$11,$12,$13
             BYTE   $14,$15,$17,$19,$1a,$ff,$c9,$02  ;ascii "......I."
             BYTE   $00,$01,$03,$05,$07,$09,$0a,$0b
             BYTE   $0c,$0d,$0e,$0f,$11,$12,$15,$16
             BYTE   $17,$19,$1a,$1d,$1f,$ff,$4a,$03  ;ascii "......J."
             BYTE   $03,$04,$05,$07,$08,$09,$0a,$0b
             BYTE   $0e,$0f,$10,$11,$12,$15,$16,$17
             BYTE   $18,$19,$1b,$1c,$1d,$ff,$41,$01  ;ascii "......A."
             BYTE   $00,$01,$02,$03,$04,$05,$08,$0a
             BYTE   $ff,$e7,$03,$00,$01,$02,$03,$04  ;ascii ".g......"
             BYTE   $05,$06,$07,$08,$09,$0a,$0b,$0c
             BYTE   $0d,$0e,$0f,$11,$12,$13,$14,$15
             BYTE   $16,$17,$18,$19,$1a,$1b,$1c,$1d
             BYTE   $1e,$1f,$20,$ff                  ;ascii ".. ."


L0FA4:       CALLF  L1087
             CALLF  L10DF
             INC    C
             CALLF  L10DF
             INC    C
             CALLF  L10DF
             INC    B
             CALLF  L10DF
             INC    B
             CALLF  L10DF
             DEC    C
             CALLF  L10DF
             DEC    C
             CALLF  L10DF
             DEC    B
             CALLF  L10DF
             INC    C
             CALLF  L10E9
             RET    

L0FD3:       CALLF  L1087
             CALLF  L10E9
             INC    C
             CALLF  L10E9
             INC    C
             CALLF  L10E9
             INC    B
             CALLF  L10E9
             INC    B
             CALLF  L10E9
             DEC    C
             CALLF  L10E9
             DEC    C
             CALLF  L10E9
             DEC    B
             CALLF  L10E9
             RET    

L0FFD:       CALLF  L1087
             DEC    C
             CALLF  L10DF
             INC    B
             INC    B
             CALLF  L10DF
             INC    B
             INC    C
             CALLF  L10DF
             INC    C
             INC    C
             CALLF  L10DF
             INC    C
             DEC    B
             CALLF  L10DF
             DEC    B
             DEC    B
             CALLF  L10DF
             DEC    B
             DEC    C
             CALLF  L10DF
             DEC    C
             DEC    C
             CALLF  L10DF
             RET    

L1037:       CALLF  L1087
             DEC    C
             CALLF  L10E9
             INC    B
             INC    B
             CALLF  L10E9
             INC    B
             INC    C
             CALLF  L10E9
             INC    C
             INC    C
             CALLF  L10E9
             INC    C
             DEC    B
             CALLF  L10E9
             DEC    B
             DEC    B
             CALLF  L10E9
             DEC    B
             DEC    C
             CALLF  L10E9
             DEC    C
             DEC    C
             CALLF  L10E9
             RET    

L1071:       CALLF  L1087
             INC    B
             INC    C
             CALLF  L10DF
             RET    

L107C:       CALLF  L1087
             INC    B
             INC    C
             CALLF  L10E9
             RET    

L1087:       MOV    #<vision_109d,TRL
             MOV    #>vision_109d,TRH
             AND    #$3f
             ROL    
             PUSH   ACC
             LDC    
             ST     C
             POP    ACC
             INC    ACC
             LDC    
             ST     B
             RET    

vision_109d:
             BYTE   $02,$0a,$02
             BYTE   $0e,$02,$12,$06,$0a,$06,$0e,$06
             BYTE   $12,$0a,$02,$0a,$06,$0a,$0a,$0a
             BYTE   $0e,$0a,$12,$0a,$16,$0a,$1a,$0e
             BYTE   $02,$0e,$06,$0e,$0a,$0e,$0e,$0e
             BYTE   $12,$0e,$16,$0e,$1a,$12,$02,$12
             BYTE   $06,$12,$0a,$12,$0e,$12,$12,$12
             BYTE   $16,$12,$1a,$16,$0a,$16,$0e,$16
             BYTE   $12,$1a,$0a,$1a,$0e,$1a,$12
L10DF:       CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             CALLF  L10F5
             OR     @R2
             ST     @R2
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             RET    

L10E9:       CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             CALLF  L10F5
             XOR    #$ff
             AND    @R2
             ST     @R2
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             RET    

L10F5:       LD     C
             ROL    
             ROL    
             ROL    
             BN     C, 0, L10FF
             SUB    #$02
L10FF:       MOV    #$00,XBNK
             BN     ACC, 7, L1107
             INC    XBNK
L1107:       OR     #$80
             ST     $002
             LD     B
             ROR    
             ROR    
             ROR    
             AND    #$1f
             ADD    $002
             ST     $002
             MOV    #<vision_1122,TRL
             MOV    #>vision_1122,TRH
             LD     B
             AND    #$07
             LDC    
             RET    

vision_1122:
             BYTE   $80,$40,$20,$10,$08,$04          ;ascii ".@ ..."
             BYTE   $02,$01
L112A:       PUSH   C
             PUSH   XBNK
             PUSH   $002
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             MOV    #$00,XBNK
             MOV    #$80,$002
L1138:       MOV    #$00, @R2
             INC    $002
             LD     $002
             AND    #$0f
             BNE    #$0c,L1138
             LD     $002
             ADD    #$04
             ST     $002
             LD     $002
             BNZ    L1153
             MOV    #$01,XBNK
             MOV    #$80,$002
L1153:       DBNZ   C,L1138
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             POP    $002
             POP    XBNK
             POP    C
             RET    

L115F:       MOV    #$01,C
L1162:       CALLF  L112A
             MOV    #$28,B
L1168:       CALLF  L0C51
             DBNZ   B,L1168
             INC    C
             LD     C
             BNE    #$20,L1162
             RET    

L1176:       CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             MOV    #$80,$002
             XOR    ACC
             ST     XBNK
             ST     C
L1181:       LDC    
             ST     @R2
             INC    $002
             LD     $002
             AND    #$0f
             BNE    #$0c,L1199
             LD     $002
             ADD    #$04
             ST     $002
             BNZ    L1199
             INC    XBNK
             MOV    #$80,$002
L1199:       INC    C
             LD     C
             BNE    #$c0,L1181
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             RET    

L11A3:       CALLF  L1230
             MOV    #<vision_12a6,TRL
             MOV    #>vision_12a6,TRH
             MOV    #$00,VRMAD1
             MOV    #$00,VRMAD2
             CLR1   VSEL, 4
             LD     $01a
L11B6:       ST     B
L11B8:       LDC    
             BZ     L11DB
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             ST     C
L11BF:       PUSH   B
             PUSH   VRMAD1
             MOV    #$06,B
             CLR1   PSW, 7             ;clear carry flag
L11C8:       LD     VTRBF       ;read from work RAM
             RORC   
             ST     VTRBF       ;write to work RAM
             INC    VRMAD1
             DBNZ   B,L11C8
             POP    VRMAD1
             POP    B
             DBNZ   C,L11BF
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
L11DB:       LD     VRMAD1
             ADD    #$06
             ST     VRMAD1
             BE     #$c0,L11EF
             INC    B
             LD     B
             BNE    #$25,L11B8
             XOR    ACC
             BR     L11B6

L11EF:       LD     $01a
             INC    ACC
             BNE    #$25,L11FA
             INC    $012
             XOR    ACC
L11FA:       ST     $01a
             CALLF  L124B
             MOV    #$00,VRMAD1
             MOV    #$00,VRMAD2
             SET1   VSEL, 4
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             MOV    #$00,XBNK
L120C:       MOV    #$80,$002
             MOV    #$08,C
L1212:       MOV    #$0c,B
L1215:       LD     VTRBF       ;read from work RAM
             ST     @R2
             INC    $002
             DBNZ   B,L1215
             LD     $002
             ADD    #$04
             ST     $002
             DBNZ   C,L1212
             BP     XBNK, 0, L122D
             INC    XBNK
             BR     L120C

L122D:       SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             RET    

L1230:       CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             MOV    #$00,VRMAD1
             MOV    #$00,VRMAD2
             SET1   VSEL, 4
             XOR    ACC
             ST     B
L123E:       LDC    
             ST     VTRBF       ;write to work RAM
             INC    B
             LD     B
             BNE    #$c0,L123E
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             RET    

L124B:       CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             MOV    #<vision_1923,TRL
             MOV    #>vision_1923,TRH
             MOV    #$0c,VRMAD1
             MOV    #$00,VRMAD2
             CLR1   VSEL, 4
             MOV    #$12,C
             CALLF  L1278
             MOV    #<vision_1935,TRL
             MOV    #>vision_1935,TRH
             MOV    #$99,VRMAD1
             MOV    #$00,VRMAD2
             CLR1   VSEL, 4
             MOV    #$15,C
             CALLF  L1278
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             RET    

L1278:       MOV    #$00,B
L127B:       LD     B
             LDC    
             OR     VTRBF
             ST     VTRBF       ;write to work RAM
             INC    VRMAD1
             INC    B
             LD     B
             LDC    
             OR     VTRBF
             ST     VTRBF       ;write to work RAM
             INC    VRMAD1
             INC    B
             LD     B
             LDC    
             OR     VTRBF
             ST     VTRBF       ;write to work RAM
             LD     VRMAD1
             ADD    #$04
             ST     VRMAD1
             INC    B
             LD     B
             BNE    C,L127B
             RET    

vision_12a6:
             BYTE   $00,$00
             BYTE   $00,$00,$00,$00,$00,$00,$00,$00
             BYTE   $00,$00,$00,$00,$00,$00,$00,$00
             BYTE   $00,$00,$00,$00,$00,$00,$00,$00
             BYTE   $00,$00,$00,$00,$01,$01,$02,$02
             BYTE   $02,$01,$01
L12CB:       MOV    #$94,$002
             MOV    #$00,B
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             MOV    #$05,C
L12D6:       LD     B
             LDC    
             ST     @R2
             INC    B
             INC    $002
             LD     B
             LDC    
             ST     @R2
             INC    B
             LD     $002
             BN     ACC, 3, L12EB
             ADD    #$04
L12EB:       ADD    #$05
             ST     $002
             DBNZ   C,L12D6
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             RET    

L12F5:       CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             MOV    #$00,XBNK
             MOV    #<vision_1771,TRL
             MOV    #>vision_1771,TRH
             LD     $016
             ST     C
             LD     $017
             AND    #$7f
             MOV    #$0a,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             MOV    #$cb,$002
             MOV    #$f0,$018
             MOV    #$0f,$019
             CALLF  L1372
             MOV    #$0a,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             MOV    #$cb,$002
             MOV    #$0f,$018
             MOV    #$f0,$019
             CALLF  L1372
             LD     C
             ST     B
             MOV    #$ca,$002
             MOV    #$f0,$018
             MOV    #$0f,$019
             CALLF  L1372
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             RET    

L133B:       CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             MOV    #$01,XBNK
             MOV    #<vision_1771,TRL
             MOV    #>vision_1771,TRH
             LD     $014
             INC    ACC
             ST     C
             MOV    #$00,ACC
             MOV    #$0a,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             MOV    #$cb,$002
             MOV    #$f0,$018
             MOV    #$0f,$019
             CALLF  L1372
             MOV    #$0a,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             MOV    #$cb,$002
             MOV    #$0f,$018
             MOV    #$f0,$019
             CALLF  L1372
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             RET    

L1372:       PUSH   ACC
             PUSH   C
             LD     B
             ROL    
             ROL    
             AND    #$fc
             ADD    B
             ST     B
             MOV    #$05,C
L1383:       LD     @R2
             AND    $018
             ST     @R2
             LD     B
             LDC    
             AND    $019
             OR     @R2
             ST     @R2
             INC    B
             LD     $002
             BN     ACC, 3, L1397
             ADD    #$04
L1397:       ADD    #$06
             ST     $002
             DBNZ   C,L1383
             POP    C
             POP    ACC
             RET    

L13A3:       MOV    #$00,$01b
L13A6:       CALLF  vision_L13BA
             CALLF  L13F2
             INC    $01b
             MOV    #$e6,ACC
L13B1:       DBNZ   ACC,L13B1
             LD     $01b
             BNE    #$20,L13A6
             RET    

vision_L13BA:       LD     $01b
             ROL    
             ROL    
             ROL    
             BN     $01b, 0, L13C4
             SUB    #$02
L13C4:       MOV    #$00,XBNK
             BN     ACC, 7, L13CC
             INC    XBNK
L13CC:       OR     #$80
             ST     $002
             LD     $01b
             ROL    
             ROL    
             AND    #$fc
             ST     C
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             MOV    #<vision_19de,TRL
             MOV    #>vision_19de,TRH
             MOV    #$04,B
L13E3:       LD     C
             LDC    
             OR     @R2
             ST     @R2
             INC    $002
             INC    C
             DBNZ   B,L13E3
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             RET    

L13F2:       LD     $01b
             ROR    
             ROR    
             ROR    
             AND    #$1f
             ST     B
             ADD    #$80
             ST     $002
             MOV    #$00,XBNK
             MOV    #<vision_1122,TRL
             MOV    #>vision_1122,TRH
             LD     $01b
             AND    #$07
             LDC    
             ST     $018
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             MOV    #<vision_195e,TRL
             MOV    #>vision_195e,TRH
L1417:       MOV    #$08,C
L141A:       LD     B
             LDC    
             AND    $018
             OR     @R2
             ST     @R2
             LD     $002
             ADD    #$06
             ST     $002
             LD     B
             ADD    #$04
             LDC    
             AND    $018
             OR     @R2
             ST     @R2
             LD     B
             ADD    #$08
             ST     B
             LD     $002
             ADD    #$0a
             ST     $002
             DBNZ   C,L141A
             BP     XBNK, 0, vision_L1448
             INC    XBNK
             SET1   $002, 7
             BR     L1417

vision_L1448:       SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             RET    

L144B:       ST     B
             ROL    
             ROL    
             ROL    
             BN     B, 0, L1455
             SUB    #$02
L1455:       MOV    #$00,XBNK
             BN     ACC, 7, L145D
             INC    XBNK
L145D:       OR     #$80
             ST     $002
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             MOV    #$00,B
L1466:       MOV    #$0c,C
L1469:       LD     B
             LDC    
             ST     @R2
             INC    B
             INC    $002
             DBNZ   C,L1469
             LD     $002
             ADD    #$04
             BP     ACC, 7, L147F
             INC    XBNK
             SET1   ACC, 7
L147F:       ST     $002
             LD     B
             BNE    #$3c,L1466
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             RET    

L1489:       LD     $015
             ST     C
             XOR    ACC
             MOV    #$0a,B
             DIV                         ; ACC:C remainder B <- ACC:C / B
             LD     C
             ROL    
             ROL    
             ROL    
             AND    #$f8
             ST     C
             LD     B
             ROL    
             ROL    
             ROL    
             AND    #$f8
             ST     B
             MOV    #<vision_1721,TRL
             MOV    #>vision_1721,TRH
             MOV    #$01,XBNK
             MOV    #$88,$002
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             MOV    #$08,ACC
L14B6:       PUSH   ACC
             LD     C
             LDC    
             ST     @R2
             INC    C
             INC    $002
             LD     B
             LDC    
             ST     @R2
             INC    B
             LD     $002
             BN     ACC, 3, L14CD
             ADD    #$04
L14CD:       ADD    #$05
             ST     $002
             POP    ACC
             DBNZ   ACC,L14B6
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             RET    

L14D9:       CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             CALLF  vision_L1532
             LD     $022
             ST     C
             XOR    ACC
             MOV    #$06,B
             MUL                         ; B:ACC:C <- ACC:C * B
             XCH    C
             ADD    TRL
             ST     TRL
             LD     C
             ADDC   TRH
             ST     TRH
             XOR    ACC
             ST     B
L14F8:       LDC    
             ST     @R3
             INC    $003
             INC    B
             LD     B
             BNE    #$06,L14F8
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             MOV    #$01,B
             CALLF  L0C34
             INC    $022
             RET    

L150E:       PUSH   B
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             CALLF  vision_L1532
             XOR    ACC
             ST     B
L1519:       MOV    #$00, @R3
             INC    $003
             INC    B
             LD     B
             BNE    #$06,L1519
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             MOV    #$01,B
             CALLF  L0C34
             POP    B
             DBNZ   B,L150E
             RET    

vision_L1532:       MOV    #$00,XBNK
             CALLF  L1550
             MOV    #$80,$002
             MOV    #$06,B
L153E:       MOV    #$01,XBNK
             LD     @R2
             MOV    #$00,XBNK
             ST     @R3
             INC    $002
             INC    $003
             DBNZ   B,L153E
             MOV    #$01,XBNK
L1550:       MOV    #$86,$002
             MOV    #$80,$003
             MOV    #$0f,C
L1559:       MOV    #$06,B
vision_L155C:       LD     @R2
             ST     @R3
             INC    $002
             INC    $003
             DBNZ   B,vision_L155C
             LD     $002
             AND    #$0f
             BNE    #$0c,L1574
             LD     $002
             ADD    #$04
             ST     $002
             BR     L157A

L1574:       LD     $003
             ADD    #$04
             ST     $003
L157A:       DBNZ   C,L1559
             RET    

L157E:       PUSH   ACC
             PUSH   B
             PUSH   C
             PUSH   TRL
             PUSH   TRH
             MOV    #$00,T1CNT        ;Stop Timer1 (sound off)
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             MOV    #$6d,$001
             MOV    #$00,XBNK
             MOV    #$90,$002
             MOV    #$42,C
L1599:       LD     @R2
             ST     @R1
             INC    $001
             INC    $002
             LD     $002
             AND    #$0f
             BNE    #$0c,L15AC
             LD     $002
             ADD    #$04
             ST     $002
L15AC:       DBNZ   C,L1599
             MOV    #$ff,ACC
             XCH    $013
             MOV    #<vision_16c9,TRL
             MOV    #>vision_16c9,TRH
             BZ     L15C5
             MOV    #$00,$013
             MOV    #<vision_16f5,TRL
             MOV    #>vision_16f5,TRH
L15C5:       MOV    #$00,XBNK
             MOV    #$90,$002
             MOV    #$0b,B
             MOV    #$00,C
L15D1:       LD     @R2
             OR     #$01
             ST     @R2
             INC    $002
L15D7:       LD     C
             LDC    
             ST     @R2
             INC    $002
             INC    C
             LD     C
             AND    #$03
             BNZ    L15D7
             LD     @R2
             OR     #$80
             ST     @R2
             INC    $002
             LD     $002
             AND    #$0f
             BNE    #$0c,L15F8
             LD     $002
             ADD    #$04
             ST     $002
L15F8:       DBNZ   B,L15D1
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             MOV    #$00,$010
vision_L1600:       LD     $010
             BNE    #$02,vision_L1600
             CLR1   OCR, 5      ;clear subclock mode (set to 600kHz)
             MOV    #$6d,$001
             MOV    #$00,XBNK
             MOV    #$90,$002
             MOV    #$42,C
L1613:       LD     @R1
             ST     @R2
             INC    $001
             INC    $002
             LD     $002
             AND    #$0f
             BNE    #$0c,L1626
             LD     $002
             ADD    #$04
             ST     $002
L1626:       DBNZ   C,L1613
             SET1   OCR, 5      ;set subclock mode (set to 32kHz)
             POP    TRH
             POP    TRL
             POP    C
             POP    B
             POP    ACC
             RET    

L1636:       BP     $013, 7, L163A
             RET    

L163A:       MOV    #$00,T1CNT        ;Stop Timer1 (sound off)
             MOV    #<vision_166b,TRL
             MOV    #>vision_166b,TRH
             ST     C
L1645:       LD     C
             LDC    
             BZ     L1667
             ST     B
             INC    C
             LD     C
             LDC    
             INC    C
             ST     T1L
             ROR    
             OR     #$80
             ST     T1LC
             SET1   T1CNT, 6
L165C:       MOV    #$14,ACC
L165F:       DBNZ   ACC,L165F
             DBNZ   B,L165C
             BR     L1645

L1667:       MOV    #$00,T1CNT        ;Stop Timer1 (sound off)
             RET    

